import{S as yb,i as wb,s as Eb,e as n,k as l,w as $,t as r,M as Ab,c as s,d as a,m as i,a as c,x as b,h as o,b as p,G as e,g as _,y,q as w,o as E,B as A,v as kb,L as Tc}from"../../chunks/vendor-hf-doc-builder.js";import{T as fe}from"../../chunks/Tip-hf-doc-builder.js";import{D as P}from"../../chunks/Docstring-hf-doc-builder.js";import{C as R}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as F}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Dc}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function xb(D){let d,x;return{c(){d=n("p"),x=r("Step three is optional, but considered a best practice.")},l(u){d=s(u,"P",{});var g=c(d);x=o(g,"Step three is optional, but considered a best practice."),g.forEach(a)},m(u,g){_(u,d,g),e(d,x)},d(u){u&&a(d)}}}function jb(D){let d,x;return{c(){d=n("p"),x=r("Step five is mandatory when using distributed evaluation")},l(u){d=s(u,"P",{});var g=c(d);x=o(g,"Step five is mandatory when using distributed evaluation"),g.forEach(a)},m(u,g){_(u,d,g),e(d,x)},d(u){u&&a(d)}}}function Pb(D){let d,x,u,g,j;return g=new R({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(gradient_accumulation_steps=2)
dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

with accelerator.accumulate():
    for input, output in dataloader:
        outputs = model(input)
        loss = loss_func(outputs)
        loss.backward()
        optimizer.step()
        scheduler.step()
        optimizer.zero_grad()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(gradient_accumulation_steps=<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.accumulate():
<span class="hljs-meta">... </span>    <span class="hljs-keyword">for</span> <span class="hljs-built_in">input</span>, output <span class="hljs-keyword">in</span> dataloader:
<span class="hljs-meta">... </span>        outputs = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>        loss = loss_func(outputs)
<span class="hljs-meta">... </span>        loss.backward()
<span class="hljs-meta">... </span>        optimizer.step()
<span class="hljs-meta">... </span>        scheduler.step()
<span class="hljs-meta">... </span>        optimizer.zero_grad()`}}),{c(){d=n("p"),x=r("Example:"),u=l(),$(g.$$.fragment)},l(h){d=s(h,"P",{});var k=c(d);x=o(k,"Example:"),k.forEach(a),u=i(h),b(g.$$.fragment,h)},m(h,k){_(h,d,k),e(d,x),_(h,u,k),y(g,h,k),j=!0},p:Tc,i(h){j||(w(g.$$.fragment,h),j=!0)},o(h){E(g.$$.fragment,h),j=!1},d(h){h&&a(d),h&&a(u),A(g,h)}}}function Db(D){let d,x,u,g,j;return g=new R({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(gradient_accumulation_steps=2)
dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

for (input, target) in dataloader:
    optimizer.zero_grad()
    output = model(input)
    loss = loss_func(output, target)
    accelerator.backward(loss)
    if accelerator.sync_gradients:
        accelerator.clip_grad_norm_(model.parameters(), max_grad_norm)
    optimizer.step()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(gradient_accumulation_steps=<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> (<span class="hljs-built_in">input</span>, target) <span class="hljs-keyword">in</span> dataloader:
<span class="hljs-meta">... </span>    optimizer.zero_grad()
<span class="hljs-meta">... </span>    output = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>    loss = loss_func(output, target)
<span class="hljs-meta">... </span>    accelerator.backward(loss)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">if</span> accelerator.sync_gradients:
<span class="hljs-meta">... </span>        accelerator.clip_grad_norm_(model.parameters(), max_grad_norm)
<span class="hljs-meta">... </span>    optimizer.step()`}}),{c(){d=n("p"),x=r("Example:"),u=l(),$(g.$$.fragment)},l(h){d=s(h,"P",{});var k=c(d);x=o(k,"Example:"),k.forEach(a),u=i(h),b(g.$$.fragment,h)},m(h,k){_(h,d,k),e(d,x),_(h,u,k),y(g,h,k),j=!0},p:Tc,i(h){j||(w(g.$$.fragment,h),j=!0)},o(h){E(g.$$.fragment,h),j=!1},d(h){h&&a(d),h&&a(u),A(g,h)}}}function Tb(D){let d,x,u,g,j;return g=new R({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(gradient_accumulation_steps=2)
dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

for (input, target) in dataloader:
    optimizer.zero_grad()
    output = model(input)
    loss = loss_func(output, target)
    accelerator.backward(loss)
    if accelerator.sync_gradients:
        accelerator.clip_grad_value_(model.parameters(), clip_value)
    optimizer.step()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(gradient_accumulation_steps=<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> (<span class="hljs-built_in">input</span>, target) <span class="hljs-keyword">in</span> dataloader:
<span class="hljs-meta">... </span>    optimizer.zero_grad()
<span class="hljs-meta">... </span>    output = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>    loss = loss_func(output, target)
<span class="hljs-meta">... </span>    accelerator.backward(loss)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">if</span> accelerator.sync_gradients:
<span class="hljs-meta">... </span>        accelerator.clip_grad_value_(model.parameters(), clip_value)
<span class="hljs-meta">... </span>    optimizer.step()`}}),{c(){d=n("p"),x=r("Example:"),u=l(),$(g.$$.fragment)},l(h){d=s(h,"P",{});var k=c(d);x=o(k,"Example:"),k.forEach(a),u=i(h),b(g.$$.fragment,h)},m(h,k){_(h,d,k),e(d,x),_(h,u,k),y(g,h,k),j=!0},p:Tc,i(h){j||(w(g.$$.fragment,h),j=!0)},o(h){E(g.$$.fragment,h),j=!1},d(h){h&&a(d),h&&a(u),A(g,h)}}}function zb(D){let d,x,u,g;return{c(){d=n("p"),x=n("code"),u=r("join_uneven_inputs"),g=r(` is only supported for Distributed Data Parallel training on multiple GPUs. For any other
configuration, this method will have no effect.`)},l(j){d=s(j,"P",{});var h=c(d);x=s(h,"CODE",{});var k=c(x);u=o(k,"join_uneven_inputs"),k.forEach(a),g=o(h,` is only supported for Distributed Data Parallel training on multiple GPUs. For any other
configuration, this method will have no effect.`),h.forEach(a)},m(j,h){_(j,d,h),e(d,x),e(x,u),e(d,g)},d(j){j&&a(d)}}}function Ob(D){let d,x,u,g,j;return{c(){d=n("p"),x=r("Overidding "),u=n("code"),g=r("even_batches"),j=r(" will not affect iterable-style data loaders.")},l(h){d=s(h,"P",{});var k=c(d);x=o(k,"Overidding "),u=s(k,"CODE",{});var z=c(u);g=o(z,"even_batches"),z.forEach(a),j=o(k," will not affect iterable-style data loaders."),k.forEach(a)},m(h,k){_(h,d,k),e(d,x),e(d,u),e(u,g),e(d,j)},d(h){h&&a(d)}}}function Ib(D){let d,x,u,g,j;return g=new R({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(even_batches=True)
ddp_model, optimizer, dataloader = accelerator.prepare(model, optimizer, dataloader)

with accelerator.join_uneven_inputs([ddp_model], even_batches=False):
    for input, output in dataloader:
        outputs = model(input)
        loss = loss_func(outputs)
        loss.backward()
        optimizer.step()
        optimizer.zero_grad()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(even_batches=<span class="hljs-literal">True</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>ddp_model, optimizer, dataloader = accelerator.prepare(model, optimizer, dataloader)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.join_uneven_inputs([ddp_model], even_batches=<span class="hljs-literal">False</span>):
<span class="hljs-meta">... </span>    <span class="hljs-keyword">for</span> <span class="hljs-built_in">input</span>, output <span class="hljs-keyword">in</span> dataloader:
<span class="hljs-meta">... </span>        outputs = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>        loss = loss_func(outputs)
<span class="hljs-meta">... </span>        loss.backward()
<span class="hljs-meta">... </span>        optimizer.step()
<span class="hljs-meta">... </span>        optimizer.zero_grad()`}}),{c(){d=n("p"),x=r("Example:"),u=l(),$(g.$$.fragment)},l(h){d=s(h,"P",{});var k=c(d);x=o(k,"Example:"),k.forEach(a),u=i(h),b(g.$$.fragment,h)},m(h,k){_(h,d,k),e(d,x),_(h,u,k),y(g,h,k),j=!0},p:Tc,i(h){j||(w(g.$$.fragment,h),j=!0)},o(h){E(g.$$.fragment,h),j=!1},d(h){h&&a(d),h&&a(u),A(g,h)}}}function Sb(D){let d,x,u,g,j;return{c(){d=n("p"),x=r("Should only be used in conjunction with "),u=n("a"),g=r("Accelerator.save_state()"),j=r("."),this.h()},l(h){d=s(h,"P",{});var k=c(d);x=o(k,"Should only be used in conjunction with "),u=s(k,"A",{href:!0});var z=c(u);g=o(z,"Accelerator.save_state()"),z.forEach(a),j=o(k,"."),k.forEach(a),this.h()},h(){p(u,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.save_state")},m(h,k){_(h,d,k),e(d,x),e(d,u),e(u,g),e(d,j)},d(h){h&&a(d)}}}function Lb(D){let d,x,u,g,j;return g=new R({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
dataloader, model, optimizer = accelerator.prepare(dataloader, model, optimizer)
input_a = next(iter(dataloader))
input_b = next(iter(dataloader))

with accelerator.no_sync():
    outputs = model(input_a)
    loss = loss_func(outputs)
    accelerator.backward(loss)
    # No synchronization across processes, only accumulate gradients
outputs = model(input_b)
accelerator.backward(loss)
# Synchronization across all processes
optimizer.step()
optimizer.zero_grad()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer = accelerator.prepare(dataloader, model, optimizer)
<span class="hljs-meta">&gt;&gt;&gt; </span>input_a = <span class="hljs-built_in">next</span>(<span class="hljs-built_in">iter</span>(dataloader))
<span class="hljs-meta">&gt;&gt;&gt; </span>input_b = <span class="hljs-built_in">next</span>(<span class="hljs-built_in">iter</span>(dataloader))

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.no_sync():
<span class="hljs-meta">... </span>    outputs = model(input_a)
<span class="hljs-meta">... </span>    loss = loss_func(outputs)
<span class="hljs-meta">... </span>    accelerator.backward(loss)
<span class="hljs-meta">... </span>    <span class="hljs-comment"># No synchronization across processes, only accumulate gradients</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(input_b)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.backward(loss)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Synchronization across all processes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer.step()
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer.zero_grad()`}}),{c(){d=n("p"),x=r("Example:"),u=l(),$(g.$$.fragment)},l(h){d=s(h,"P",{});var k=c(d);x=o(k,"Example:"),k.forEach(a),u=i(h),b(g.$$.fragment,h)},m(h,k){_(h,d,k),e(d,x),_(h,u,k),y(g,h,k),j=!0},p:Tc,i(h){j||(w(g.$$.fragment,h),j=!0)},o(h){E(g.$$.fragment,h),j=!1},d(h){h&&a(d),h&&a(u),A(g,h)}}}function Cb(D){let d,x;return{c(){d=n("p"),x=r("You don\u2019t need to prepare a model if you only use it for inference without any kind of mixed precision")},l(u){d=s(u,"P",{});var g=c(d);x=o(g,"You don\u2019t need to prepare a model if you only use it for inference without any kind of mixed precision"),g.forEach(a)},m(u,g){_(u,d,g),e(d,x)},d(u){u&&a(d)}}}function Nb(D){let d,x,u,g,j,h,k,z,ge,Ve,H;return{c(){d=n("p"),x=r("Every "),u=n("code"),g=r("object"),j=r(" must have a "),h=n("code"),k=r("load_state_dict"),z=r(" and "),ge=n("code"),Ve=r("state_dict"),H=r(" function to be stored.")},l(_e){d=s(_e,"P",{});var S=c(d);x=o(S,"Every "),u=s(S,"CODE",{});var Fr=c(u);g=o(Fr,"object"),Fr.forEach(a),j=o(S," must have a "),h=s(S,"CODE",{});var Hr=c(h);k=o(Hr,"load_state_dict"),Hr.forEach(a),z=o(S," and "),ge=s(S,"CODE",{});var ha=c(ge);Ve=o(ha,"state_dict"),ha.forEach(a),H=o(S," function to be stored."),S.forEach(a)},m(_e,S){_(_e,d,S),e(d,x),e(d,u),e(u,g),e(d,j),e(d,h),e(h,k),e(d,z),e(d,ge),e(ge,Ve),e(d,H)},d(_e){_e&&a(d)}}}function qb(D){let d,x,u,g,j;return{c(){d=n("p"),x=r("Should only be used in conjunction with "),u=n("a"),g=r("Accelerator.register_save_state_pre_hook()"),j=r(`. Can be useful to load
configurations in addition to model weights. Can also be used to overwrite model loading with a customized
method. In this case, make sure to remove already loaded models from the models list.`),this.h()},l(h){d=s(h,"P",{});var k=c(d);x=o(k,"Should only be used in conjunction with "),u=s(k,"A",{href:!0});var z=c(u);g=o(z,"Accelerator.register_save_state_pre_hook()"),z.forEach(a),j=o(k,`. Can be useful to load
configurations in addition to model weights. Can also be used to overwrite model loading with a customized
method. In this case, make sure to remove already loaded models from the models list.`),k.forEach(a),this.h()},h(){p(u,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.register_save_state_pre_hook")},m(h,k){_(h,d,k),e(d,x),e(d,u),e(u,g),e(d,j)},d(h){h&&a(d)}}}function Ub(D){let d,x,u,g,j;return{c(){d=n("p"),x=r("Should only be used in conjunction with "),u=n("a"),g=r("Accelerator.register_load_state_pre_hook()"),j=r(`. Can be useful to save
configurations in addition to model weights. Can also be used to overwrite model saving with a customized
method. In this case, make sure to remove already loaded weights from the weights list.`),this.h()},l(h){d=s(h,"P",{});var k=c(d);x=o(k,"Should only be used in conjunction with "),u=s(k,"A",{href:!0});var z=c(u);g=o(z,"Accelerator.register_load_state_pre_hook()"),z.forEach(a),j=o(k,`. Can be useful to save
configurations in addition to model weights. Can also be used to overwrite model saving with a customized
method. In this case, make sure to remove already loaded weights from the weights list.`),k.forEach(a),this.h()},h(){p(u,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.register_load_state_pre_hook")},m(h,k){_(h,d,k),e(d,x),e(d,u),e(u,g),e(d,j)},d(h){h&&a(d)}}}function Rb(D){let d,x;return{c(){d=n("p"),x=r(`Should only be used when wanting to save a checkpoint during training and restoring the state in the same
environment.`)},l(u){d=s(u,"P",{});var g=c(d);x=o(g,`Should only be used when wanting to save a checkpoint during training and restoring the state in the same
environment.`),g.forEach(a)},m(u,g){_(u,d,g),e(d,x)},d(u){u&&a(d)}}}function Mb(D){let d,x,u,g,j,h,k,z,ge,Ve,H,_e,S,Fr,Hr,ha,ve,Ge,Co,ma,Di,No,Ti,zc,Yr,zi,Oc,te,$e,Oi,Br,Ii,Si,qo,Li,Ci,Ni,ua,qi,Jr,Ui,Ri,Mi,X,Vi,Uo,Gi,Wi,Ro,Fi,Hi,Mo,Yi,Bi,Ic,We,Sc,be,Fe,Ji,Vo,Ki,Qi,Go,Xi,Zi,Kr,ed,Qr,td,Lc,He,Cc,Ye,ad,Wo,rd,od,Nc,ye,Be,Fo,fa,nd,Ho,sd,qc,we,Je,Yo,ga,cd,Bo,ld,Uc,Ee,Jo,id,dd,Xr,pd,hd,Rc,_a,Mc,Ae,Ke,Ko,va,md,Qo,ud,Vc,ke,Qe,Xo,$a,fd,Zo,gd,Gc,Xe,_d,en,vd,$d,Wc,ba,Fc,Ze,bd,Zr,yd,wd,Hc,ya,Yc,xe,et,tn,wa,Ed,an,Ad,Bc,tt,kd,rn,xd,jd,Jc,Ea,Kc,at,Pd,eo,Dd,Td,Qc,Aa,Xc,je,rt,on,ka,zd,nn,Od,Zc,to,Id,el,xa,tl,ja,al,Pe,ot,sn,Pa,Sd,cn,Ld,rl,nt,Cd,ao,Nd,qd,ol,De,st,ln,Da,Ud,dn,Rd,nl,ct,Md,ro,Vd,Gd,sl,Ta,cl,ae,Wd,oo,Fd,Hd,pn,Yd,Bd,ll,za,il,Te,lt,hn,Oa,Jd,mn,Kd,dl,W,Qd,it,Xd,un,Zd,ep,tp,fn,ap,rp,dt,op,gn,np,sp,cp,_n,lp,pl,ze,pt,vn,Ia,ip,$n,dp,hl,ht,pp,no,hp,mp,ml,Sa,ul,Oe,mt,bn,La,up,yn,fp,fl,f,Ca,gp,wn,_p,vp,En,An,$p,bp,T,ut,kn,yp,wp,xn,Ep,Ap,kp,ft,jn,xp,jp,so,Pp,Dp,Tp,gt,Pn,zp,Op,Dn,Ip,Sp,Lp,_t,Tn,Cp,Np,zn,qp,Up,Rp,vt,On,Mp,Vp,In,Gp,Wp,Fp,$t,Sn,Hp,Yp,Ln,Bp,Jp,Kp,bt,Cn,Qp,Xp,Nn,Zp,eh,th,yt,qn,ah,rh,co,oh,nh,sh,wt,Un,ch,lh,Rn,ih,dh,ph,Et,Mn,hh,mh,Vn,uh,fh,gh,re,Na,_h,Gn,vh,$h,At,bh,kt,qa,yh,Wn,wh,Eh,oe,Ua,Ah,Ie,kh,Fn,xh,jh,Hn,Ph,Dh,Th,Ra,zh,Yn,Oh,Ih,Sh,xt,Ma,Lh,Va,Ch,Bn,Nh,qh,Uh,ne,Ga,Rh,Wa,Mh,Jn,Vh,Gh,Wh,jt,Fh,se,Fa,Hh,Ha,Yh,Kn,Bh,Jh,Kh,Pt,Qh,Dt,Ya,Xh,Qn,Zh,em,Tt,Ba,tm,Xn,am,rm,ce,Ja,om,Ka,nm,Zn,sm,cm,lm,es,im,dm,zt,Qa,pm,Xa,hm,ts,mm,um,fm,Ot,Za,gm,er,_m,lo,vm,$m,bm,It,tr,ym,Z,wm,as,Em,Am,rs,km,xm,os,jm,Pm,Dm,St,ar,Tm,rr,zm,ns,Om,Im,Sm,M,or,Lm,nr,Cm,ss,Nm,qm,Um,Lt,Rm,Ct,Mm,Nt,Vm,le,sr,Gm,cs,Wm,Fm,qt,Hm,ie,cr,Ym,ls,Bm,Jm,is,Km,Qm,Ut,lr,Xm,Se,Zm,ds,eu,tu,ps,au,ru,ou,de,ir,nu,hs,su,cu,ms,lu,iu,Y,dr,du,pr,pu,us,hu,mu,uu,hr,fu,fs,gu,_u,vu,Rt,$u,Mt,mr,bu,gs,yu,wu,Vt,ur,Eu,_s,Au,ku,Gt,fr,xu,vs,ju,Pu,Wt,gr,Du,$s,Tu,zu,Ft,_r,Ou,bs,Iu,Su,Ht,vr,Lu,ys,Cu,Nu,pe,$r,qu,br,Uu,ws,Ru,Mu,Vu,Yt,Gu,Bt,yr,Wu,wr,Fu,io,Hu,Yu,Bu,Jt,Er,Ju,Ar,Ku,po,Qu,Xu,Zu,Kt,kr,ef,xr,tf,ho,af,rf,of,Qt,jr,nf,Pr,sf,mo,cf,lf,df,Xt,Dr,pf,Tr,hf,Es,mf,uf,ff,he,zr,gf,Le,_f,As,vf,$f,ks,bf,yf,wf,xs,Ef,Af,B,Or,kf,ee,xf,js,jf,Pf,Ps,Df,Tf,Ds,zf,Of,If,Ts,Sf,Lf,Zt,Cf,C,Ir,Nf,Ce,qf,zs,Uf,Rf,uo,Mf,Vf,Gf,Os,Wf,Ff,Is,Ss,Hf,Yf,U,Bf,Ls,Jf,Kf,Cs,Qf,Xf,Ns,Zf,eg,qs,tg,ag,fo,rg,og,ng,ea,sg,N,Sr,cg,Ne,lg,Us,ig,dg,go,pg,hg,mg,Rs,ug,fg,Ms,Vs,gg,_g,I,vg,Gs,$g,bg,Ws,yg,wg,Fs,Eg,Ag,Hs,kg,xg,Ys,jg,Pg,Bs,Dg,Tg,_o,zg,Og,Ig,ta,Sg,aa,Lr,Lg,Cr,Cg,Js,Ng,qg,Ug,V,Nr,Rg,Ks,Mg,Vg,L,Gg,Qs,Wg,Fg,Xs,Hg,Yg,Zs,Bg,Jg,ec,Kg,Qg,tc,Xg,Zg,ac,e_,t_,a_,qr,r_,rc,o_,n_,s_,ra,c_,oa,Ur,l_,oc,i_,d_,na,Rr,p_,qe,h_,nc,m_,u_,vo,f_,g_,__,sa,Mr,v_,sc,$_,gl;return h=new F({}),ma=new F({}),We=new fe({props:{$$slots:{default:[xb]},$$scope:{ctx:D}}}),He=new fe({props:{warning:!0,$$slots:{default:[jb]},$$scope:{ctx:D}}}),fa=new F({}),ga=new F({}),_a=new R({props:{code:`- print("My thing I want to print!")
+ accelerator.print("My thing I want to print!")`,highlighted:`<span class="hljs-deletion">- print(&quot;My thing I want to print!&quot;)</span>
<span class="hljs-addition">+ accelerator.print(&quot;My thing I want to print!&quot;)</span>`}}),va=new F({}),$a=new F({}),ba=new R({props:{code:`if accelerator.is_local_main_process:
    do_thing_once_per_server()`,highlighted:`<span class="hljs-keyword">if</span> accelerator.is_local_main_process:
    do_thing_once_per_server()`}}),ya=new R({props:{code:`@accelerator.on_local_main_process
def do_my_thing():
    "Something done once per server"
    do_thing_once_per_server()`,highlighted:`<span class="hljs-meta">@accelerator.on_local_main_process</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">do_my_thing</span>():
    <span class="hljs-string">&quot;Something done once per server&quot;</span>
    do_thing_once_per_server()`}}),wa=new F({}),Ea=new R({props:{code:`if accelerator.is_main_process:
    do_thing_once()`,highlighted:`<span class="hljs-keyword">if</span> accelerator.is_main_process:
    do_thing_once()`}}),Aa=new R({props:{code:`@accelerator.on_main_process
def do_my_thing():
    "Something done once per server"
    do_thing_once()`,highlighted:`<span class="hljs-meta">@accelerator.on_main_process</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">do_my_thing</span>():
    <span class="hljs-string">&quot;Something done once per server&quot;</span>
    do_thing_once()`}}),ka=new F({}),xa=new R({props:{code:`@accelerator.on_local_process(local_process_idx=0)
def do_my_thing():
    "Something done on process index 0 on each server"
    do_thing_on_index_zero_on_each_server()`,highlighted:`<span class="hljs-meta">@accelerator.on_local_process(<span class="hljs-params">local_process_idx=<span class="hljs-number">0</span></span>)</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">do_my_thing</span>():
    <span class="hljs-string">&quot;Something done on process index 0 on each server&quot;</span>
    do_thing_on_index_zero_on_each_server()`}}),ja=new R({props:{code:`@accelerator.on_process(process_index=0)
def do_my_thing():
    "Something done on process index 0"
    do_thing_on_index_zero()`,highlighted:`<span class="hljs-meta">@accelerator.on_process(<span class="hljs-params">process_index=<span class="hljs-number">0</span></span>)</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">do_my_thing</span>():
    <span class="hljs-string">&quot;Something done on process index 0&quot;</span>
    do_thing_on_index_zero()`}}),Pa=new F({}),Da=new F({}),Ta=new R({props:{code:`model = MyModel()
model = accelerator.prepare(model)
# Unwrap
model = accelerator.unwrap_model(model)`,highlighted:`model = MyModel()
model = accelerator.prepare(model)
<span class="hljs-comment"># Unwrap</span>
model = accelerator.unwrap_model(model)`}}),za=new R({props:{code:`  state_dict = model.state_dict()
- torch.save(state_dict, "my_state.pkl")
+ accelerator.save(state_dict, "my_state.pkl")`,highlighted:`  state_dict = model.state_dict()
<span class="hljs-deletion">- torch.save(state_dict, &quot;my_state.pkl&quot;)</span>
<span class="hljs-addition">+ accelerator.save(state_dict, &quot;my_state.pkl&quot;)</span>`}}),Oa=new F({}),Ia=new F({}),Sa=new R({props:{code:`- accelerator = Accelerator()
+ accelerator = Accelerator(gradient_accumulation_steps=2)

  for (input, label) in training_dataloader:
+     with accelerator.accumulate(model):
          predictions = model(input)
          loss = loss_function(predictions, labels)
          accelerator.backward(loss)
          optimizer.step()
          scheduler.step()
          optimizer.zero_grad()`,highlighted:`<span class="hljs-deletion">- accelerator = Accelerator()</span>
<span class="hljs-addition">+ accelerator = Accelerator(gradient_accumulation_steps=2)</span>

  for (input, label) in training_dataloader:
<span class="hljs-addition">+     with accelerator.accumulate(model):</span>
          predictions = model(input)
          loss = loss_function(predictions, labels)
          accelerator.backward(loss)
          optimizer.step()
          scheduler.step()
          optimizer.zero_grad()`}}),La=new F({}),Ca=new P({props:{name:"class accelerate.Accelerator",anchor:"accelerate.Accelerator",parameters:[{name:"device_placement",val:": bool = True"},{name:"split_batches",val:": bool = False"},{name:"mixed_precision",val:": typing.Union[accelerate.utils.dataclasses.PrecisionType, str] = None"},{name:"gradient_accumulation_steps",val:": int = 1"},{name:"cpu",val:": bool = False"},{name:"deepspeed_plugin",val:": DeepSpeedPlugin = None"},{name:"fsdp_plugin",val:": FullyShardedDataParallelPlugin = None"},{name:"megatron_lm_plugin",val:": MegatronLMPlugin = None"},{name:"rng_types",val:": typing.Union[typing.List[typing.Union[str, accelerate.utils.dataclasses.RNGType]], NoneType] = None"},{name:"log_with",val:": typing.Union[typing.List[typing.Union[str, accelerate.utils.dataclasses.LoggerType, accelerate.tracking.GeneralTracker]], NoneType] = None"},{name:"project_dir",val:": typing.Union[str, os.PathLike, NoneType] = None"},{name:"project_config",val:": typing.Optional[accelerate.utils.dataclasses.ProjectConfiguration] = None"},{name:"logging_dir",val:": typing.Union[str, os.PathLike, NoneType] = None"},{name:"dispatch_batches",val:": typing.Optional[bool] = None"},{name:"even_batches",val:": bool = True"},{name:"step_scheduler_with_optimizer",val:": bool = True"},{name:"kwargs_handlers",val:": typing.Optional[typing.List[accelerate.utils.dataclasses.KwargsHandler]] = None"},{name:"dynamo_backend",val:": typing.Union[accelerate.utils.dataclasses.DynamoBackend, str] = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.device_placement",description:`<strong>device_placement</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not the accelerator should put objects on device (tensors yielded by the dataloader, model,
etc&#x2026;).`,name:"device_placement"},{anchor:"accelerate.Accelerator.split_batches",description:`<strong>split_batches</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the accelerator should split the batches yielded by the dataloaders across the devices. If
<code>True</code> the actual batch size used will be the same on any kind of distributed processes, but it must be a
round multiple of the <code>num_processes</code> you are using. If <code>False</code>, actual batch size used will be the one set
in your script multiplied by the number of processes.`,name:"split_batches"},{anchor:"accelerate.Accelerator.mixed_precision",description:`<strong>mixed_precision</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Whether or not to use mixed precision training (fp16 or bfloat16). Choose from &#x2018;no&#x2019;,&#x2018;fp16&#x2019;,&#x2018;bf16&#x2019;. Will
default to the value in the environment variable <code>ACCELERATE_MIXED_PRECISION</code>, which will use the default
value in the accelerate config of the current system or the flag passed with the <code>accelerate.launch</code>
command. &#x2018;fp16&#x2019; requires pytorch 1.6 or higher. &#x2018;bf16&#x2019; requires pytorch 1.10 or higher.`,name:"mixed_precision"},{anchor:"accelerate.Accelerator.gradient_accumulation_steps",description:`<strong>gradient_accumulation_steps</strong> (<code>int</code>, <em>optional</em>, default to 1) &#x2014;
The number of steps that should pass before gradients are accumulated. A number &gt; 1 should be combined with
<code>Accelerator.accumulate</code>. If not passed, will default to the value in the environment variable
<code>ACCELERATE_GRADIENT_ACCUMULATION_STEPS</code>.`,name:"gradient_accumulation_steps"},{anchor:"accelerate.Accelerator.cpu",description:`<strong>cpu</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to force the script to execute on CPU. Will ignore GPU available if set to <code>True</code> and force
the execution on one process only.`,name:"cpu"},{anchor:"accelerate.Accelerator.deepspeed_plugin",description:`<strong>deepspeed_plugin</strong> (<code>DeepSpeedPlugin</code>, <em>optional</em>) &#x2014;
Tweak your DeepSpeed related args using this argument. This argument is optional and can be configured
directly using <em>accelerate config</em>`,name:"deepspeed_plugin"},{anchor:"accelerate.Accelerator.fsdp_plugin",description:`<strong>fsdp_plugin</strong> (<code>FullyShardedDataParallelPlugin</code>, <em>optional</em>) &#x2014;
Tweak your FSDP related args using this argument. This argument is optional and can be configured directly
using <em>accelerate config</em>`,name:"fsdp_plugin"},{anchor:"accelerate.Accelerator.megatron_lm_plugin",description:`<strong>megatron_lm_plugin</strong> (<code>MegatronLMPlugin</code>, <em>optional</em>) &#x2014;
Tweak your MegatronLM related args using this argument. This argument is optional and can be configured
directly using <em>accelerate config</em>`,name:"megatron_lm_plugin"},{anchor:"accelerate.Accelerator.rng_types",description:`<strong>rng_types</strong> (list of <code>str</code> or <code>RNGType</code>) &#x2014;
The list of random number generators to synchronize at the beginning of each iteration in your prepared
dataloaders. Should be one or several of:</p>
<ul>
<li><code>&quot;torch&quot;</code>: the base torch random number generator</li>
<li><code>&quot;cuda&quot;</code>: the CUDA random number generator (GPU only)</li>
<li><code>&quot;xla&quot;</code>: the XLA random number generator (TPU only)</li>
<li><code>&quot;generator&quot;</code>: the <code>torch.Generator</code> of the sampler (or batch sampler if there is no sampler in your
dataloader) or of the iterable dataset (if it exists) if the underlying dataset is of that type.</li>
</ul>
<p>Will default to <code>[&quot;torch&quot;]</code> for PyTorch versions &lt;=1.5.1 and <code>[&quot;generator&quot;]</code> for PyTorch versions &gt;= 1.6.`,name:"rng_types"},{anchor:"accelerate.Accelerator.log_with",description:`<strong>log_with</strong> (list of <code>str</code>, <a href="/docs/accelerate/main/en/package_reference/utilities#accelerate.utils.LoggerType">LoggerType</a> or <a href="/docs/accelerate/main/en/package_reference/tracking#accelerate.tracking.GeneralTracker">GeneralTracker</a>, <em>optional</em>) &#x2014;
A list of loggers to be setup for experiment tracking. Should be one or several of:</p>
<ul>
<li><code>&quot;all&quot;</code></li>
<li><code>&quot;tensorboard&quot;</code></li>
<li><code>&quot;wandb&quot;</code></li>
<li><code>&quot;comet_ml&quot;</code>
If <code>&quot;all&quot;</code> is selected, will pick up all available trackers in the environment and initialize them. Can
also accept implementations of <code>GeneralTracker</code> for custom trackers, and can be combined with <code>&quot;all&quot;</code>.</li>
</ul>`,name:"log_with"},{anchor:"accelerate.Accelerator.project_config",description:`<strong>project_config</strong> (<code>ProjectConfiguration</code>, <em>optional</em>) &#x2014;
A configuration for how saving the state can be handled.`,name:"project_config"},{anchor:"accelerate.Accelerator.project_dir",description:`<strong>project_dir</strong> (<code>str</code>, <code>os.PathLike</code>, <em>optional</em>) &#x2014;
A path to a directory for storing data such as logs of locally-compatible loggers and potentially saved
checkpoints.`,name:"project_dir"},{anchor:"accelerate.Accelerator.dispatch_batches",description:`<strong>dispatch_batches</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, the dataloader prepared by the Accelerator is only iterated through on the main process
and then the batches are split and broadcast to each process. Will default to <code>True</code> for <code>DataLoader</code> whose
underlying dataset is an <code>IterableDataset</code>, <code>False</code> otherwise.`,name:"dispatch_batches"},{anchor:"accelerate.Accelerator.even_batches",description:`<strong>even_batches</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
If set to <code>True</code>, in cases where the total batch size across all processes does not exactly divide the
dataset, samples at the start of the dataset will be duplicated so the batch can be divided equally among
all workers.`,name:"even_batches"},{anchor:"accelerate.Accelerator.step_scheduler_with_optimizer",description:"<strong>step_scheduler_with_optimizer</strong> (<code>bool</code>, *optional<code>, defaults to </code>True<code>) -- Set </code>True<code>if the learning rate scheduler is stepped at the same time as the optimizer,</code>False` if only\ndone under certain circumstances (at the end of each epoch, for instance).",name:"step_scheduler_with_optimizer"},{anchor:"accelerate.Accelerator.kwargs_handlers",description:`<strong>kwargs_handlers</strong> (<code>List[KwargHandler]</code>, <em>optional</em>) &#x2014;
A list of <code>KwargHandler</code> to customize how the objects related to distributed training or mixed precision
are created. See <a href="kwargs">kwargs</a> for more information.`,name:"kwargs_handlers"},{anchor:"accelerate.Accelerator.dynamo_backend",description:`<strong>dynamo_backend</strong> (<code>str</code> or <code>DynamoBackend</code>, <em>optional</em>, defaults to <code>&quot;no&quot;</code>) &#x2014;
Set to one of the possible dynamo backends to optimize your training with torch dynamo.`,name:"dynamo_backend"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L112"}}),Na=new P({props:{name:"accumulate",anchor:"accelerate.Accelerator.accumulate",parameters:[{name:"model",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.accumulate.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
PyTorch Module that was prepared with <code>Accelerator.prepare</code>`,name:"model"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L634"}}),At=new Dc({props:{anchor:"accelerate.Accelerator.accumulate.example",$$slots:{default:[Pb]},$$scope:{ctx:D}}}),qa=new P({props:{name:"autocast",anchor:"accelerate.Accelerator.autocast",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1972"}}),Ua=new P({props:{name:"backward",anchor:"accelerate.Accelerator.backward",parameters:[{name:"loss",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1327"}}),Ma=new P({props:{name:"clear",anchor:"accelerate.Accelerator.clear",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1880"}}),Ga=new P({props:{name:"clip_grad_norm_",anchor:"accelerate.Accelerator.clip_grad_norm_",parameters:[{name:"parameters",val:""},{name:"max_norm",val:""},{name:"norm_type",val:" = 2"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1366",returnDescription:`
<p>Total norm of the parameter gradients (viewed as a single vector).</p>
`,returnType:`
<p><code>torch.Tensor</code></p>
`}}),jt=new Dc({props:{anchor:"accelerate.Accelerator.clip_grad_norm_.example",$$slots:{default:[Db]},$$scope:{ctx:D}}}),Fa=new P({props:{name:"clip_grad_value_",anchor:"accelerate.Accelerator.clip_grad_value_",parameters:[{name:"parameters",val:""},{name:"clip_value",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1404"}}),Pt=new Dc({props:{anchor:"accelerate.Accelerator.clip_grad_value_.example",$$slots:{default:[Tb]},$$scope:{ctx:D}}}),Ya=new P({props:{name:"end_training",anchor:"accelerate.Accelerator.end_training",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1605"}}),Ba=new P({props:{name:"free_memory",anchor:"accelerate.Accelerator.free_memory",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1868"}}),Ja=new P({props:{name:"gather",anchor:"accelerate.Accelerator.gather",parameters:[{name:"tensor",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.gather.tensor",description:`<strong>tensor</strong> (<code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code>) &#x2014;
The tensors to gather across all processes.`,name:"tensor"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1431",returnDescription:`
<p>The gathered tensor(s). Note that the
first dimension of the result is <em>num_processes</em> multiplied by the first dimension of the input tensors.</p>
`,returnType:`
<p><code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code></p>
`}}),Qa=new P({props:{name:"gather_for_metrics",anchor:"accelerate.Accelerator.gather_for_metrics",parameters:[{name:"tensor",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.gather_for_metrics.tensor",description:`<strong>tensor</strong> (<code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code>) &#x2014;
The tensors for calculating metrics across all processes.`,name:"tensor"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1449"}}),Za=new P({props:{name:"get_state_dict",anchor:"accelerate.Accelerator.get_state_dict",parameters:[{name:"model",val:""},{name:"unwrap",val:" = True"}],parametersDescription:[{anchor:"accelerate.Accelerator.get_state_dict.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
A PyTorch model sent through <a href="/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare">Accelerator.prepare()</a>`,name:"model"},{anchor:"accelerate.Accelerator.get_state_dict.unwrap",description:`<strong>unwrap</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to return the original underlying state_dict of <code>model</code> or to return the wrapped state_dict`,name:"unwrap"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1912"}}),tr=new P({props:{name:"get_tracker",anchor:"accelerate.Accelerator.get_tracker",parameters:[{name:"name",val:": str"}],parametersDescription:[{anchor:"accelerate.Accelerator.get_tracker.name",description:`<strong>name</strong> (<code>str</code>) &#x2014;
The name of a tracker, corresponding to the <code>.name</code> property.`,name:"name"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1571"}}),ar=new P({props:{name:"init_trackers",anchor:"accelerate.Accelerator.init_trackers",parameters:[{name:"project_name",val:": str"},{name:"config",val:": typing.Optional[dict] = None"},{name:"init_kwargs",val:": typing.Optional[dict] = {}"}],parametersDescription:[{anchor:"accelerate.Accelerator.init_trackers.project_name",description:`<strong>project_name</strong> (<code>str</code>) &#x2014;
The name of the project. All trackers will save their data based on this`,name:"project_name"},{anchor:"accelerate.Accelerator.init_trackers.config",description:`<strong>config</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Optional starting configuration to be logged.`,name:"config"},{anchor:"accelerate.Accelerator.init_trackers.init_kwargs",description:`<strong>init_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A nested dictionary of kwargs to be passed to a specific tracker&#x2019;s <code>__init__</code> function. Should be
formatted like so:`,name:"init_kwargs"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1536"}}),or=new P({props:{name:"join_uneven_inputs",anchor:"accelerate.Accelerator.join_uneven_inputs",parameters:[{name:"joinables",val:""},{name:"even_batches",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.join_uneven_inputs.joinables",description:`<strong>joinables</strong> (<code>List[torch.distributed.algorithms.Joinable]</code>) &#x2014;
A list of models or optimizers that subclass <code>torch.distributed.algorithms.Joinable</code>. Most commonly, a
PyTorch Module that was prepared with <code>Accelerator.prepare</code> for DistributedDataParallel training.`,name:"joinables"},{anchor:"accelerate.Accelerator.join_uneven_inputs.even_batches",description:`<strong>even_batches</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set, this will override the value of <code>even_batches</code> set in the <code>Accelerator</code>. If it is not provided,
the default <code>Accelerator</code> value wil be used.`,name:"even_batches"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L670"}}),Lt=new fe({props:{warning:!0,$$slots:{default:[zb]},$$scope:{ctx:D}}}),Ct=new fe({props:{warning:!0,$$slots:{default:[Ob]},$$scope:{ctx:D}}}),Nt=new Dc({props:{anchor:"accelerate.Accelerator.join_uneven_inputs.example",$$slots:{default:[Ib]},$$scope:{ctx:D}}}),sr=new P({props:{name:"load_state",anchor:"accelerate.Accelerator.load_state",parameters:[{name:"input_dir",val:": str"},{name:"**load_model_func_kwargs",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.load_state.input_dir",description:`<strong>input_dir</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
The name of the folder all relevant weights and states were saved in.`,name:"input_dir"},{anchor:"accelerate.Accelerator.load_state.load_model_func_kwargs",description:`<strong>load_model_func_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Additional keyword arguments for loading model which can be passed to the underlying load function,
such as optional arguments for DeepSpeed&#x2019;s <code>load_checkpoint</code> function.`,name:"load_model_func_kwargs"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1787"}}),qt=new fe({props:{$$slots:{default:[Sb]},$$scope:{ctx:D}}}),cr=new P({props:{name:"local_main_process_first",anchor:"accelerate.Accelerator.local_main_process_first",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L571"}}),lr=new P({props:{name:"log",anchor:"accelerate.Accelerator.log",parameters:[{name:"values",val:": dict"},{name:"step",val:": typing.Optional[int] = None"},{name:"log_kwargs",val:": typing.Optional[dict] = {}"}],parametersDescription:[{anchor:"accelerate.Accelerator.log.values",description:`<strong>values</strong> (<code>dict</code>) &#x2014;
Values should be a dictionary-like object containing only types <code>int</code>, <code>float</code>, or <code>str</code>.`,name:"values"},{anchor:"accelerate.Accelerator.log.step",description:`<strong>step</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The run step. If included, the log will be affiliated with this step.`,name:"step"},{anchor:"accelerate.Accelerator.log.log_kwargs",description:`<strong>log_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A nested dictionary of kwargs to be passed to a specific tracker&#x2019;s <code>log</code> function. Should be formatted
like so:`,name:"log_kwargs"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1585"}}),ir=new P({props:{name:"main_process_first",anchor:"accelerate.Accelerator.main_process_first",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L562"}}),dr=new P({props:{name:"no_sync",anchor:"accelerate.Accelerator.no_sync",parameters:[{name:"model",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.no_sync.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
PyTorch Module that was prepared with <code>Accelerator.prepare</code>`,name:"model"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L580"}}),Rt=new Dc({props:{anchor:"accelerate.Accelerator.no_sync.example",$$slots:{default:[Lb]},$$scope:{ctx:D}}}),mr=new P({props:{name:"on_last_process",anchor:"accelerate.Accelerator.on_last_process",parameters:[{name:"func",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L511"}}),ur=new P({props:{name:"on_local_main_process",anchor:"accelerate.Accelerator.on_local_main_process",parameters:[{name:"func",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L499"}}),fr=new P({props:{name:"on_local_process",anchor:"accelerate.Accelerator.on_local_process",parameters:[{name:"local_process_idx",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L538"}}),gr=new P({props:{name:"on_main_process",anchor:"accelerate.Accelerator.on_main_process",parameters:[{name:"func",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L487"}}),_r=new P({props:{name:"on_process",anchor:"accelerate.Accelerator.on_process",parameters:[{name:"process_idx",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L523"}}),vr=new P({props:{name:"pad_across_processes",anchor:"accelerate.Accelerator.pad_across_processes",parameters:[{name:"tensor",val:""},{name:"dim",val:" = 0"},{name:"pad_index",val:" = 0"},{name:"pad_first",val:" = False"}],parametersDescription:[{anchor:"accelerate.Accelerator.pad_across_processes.tensor",description:`<strong>tensor</strong> (nested list/tuple/dictionary of <code>torch.Tensor</code>) &#x2014;
The data to gather.`,name:"tensor"},{anchor:"accelerate.Accelerator.pad_across_processes.dim",description:`<strong>dim</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
The dimension on which to pad.`,name:"dim"},{anchor:"accelerate.Accelerator.pad_across_processes.pad_index",description:`<strong>pad_index</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
The value with which to pad.`,name:"pad_index"},{anchor:"accelerate.Accelerator.pad_across_processes.pad_first",description:`<strong>pad_first</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to pad at the beginning or the end.`,name:"pad_first"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1499"}}),$r=new P({props:{name:"prepare",anchor:"accelerate.Accelerator.prepare",parameters:[{name:"*args",val:""},{name:"device_placement",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare.*args",description:`<strong>*args</strong> (list of objects) &#x2014;
Any of the following type of objects:</p>
<ul>
<li><code>torch.utils.data.DataLoader</code>: PyTorch Dataloader</li>
<li><code>torch.nn.Module</code>: PyTorch Module</li>
<li><code>torch.optim.Optimizer</code>: PyTorch Optimizer</li>
<li><code>torch.optim.lr_scheduler.LRScheduler</code>: PyTorch LR Scheduler</li>
</ul>`,name:"*args"},{anchor:"accelerate.Accelerator.prepare.device_placement",description:`<strong>device_placement</strong> (<code>List[bool]</code>, <em>optional</em>) &#x2014;
Used to customize whether automatic device placement should be performed for each object passed. Needs
to be a list of the same length as <code>args</code>.`,name:"device_placement"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L827"}}),Yt=new fe({props:{$$slots:{default:[Cb]},$$scope:{ctx:D}}}),yr=new P({props:{name:"prepare_data_loader",anchor:"accelerate.Accelerator.prepare_data_loader",parameters:[{name:"data_loader",val:": DataLoader"},{name:"device_placement",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare_data_loader.data_loader",description:`<strong>data_loader</strong> (<code>torch.utils.data.DataLoader</code>) &#x2014;
A vanilla PyTorch DataLoader to prepare`,name:"data_loader"},{anchor:"accelerate.Accelerator.prepare_data_loader.device_placement",description:`<strong>device_placement</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to place the batches on the proper device in the prepared dataloader. Will default to
<code>self.device_placement</code>.`,name:"device_placement"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1258"}}),Er=new P({props:{name:"prepare_model",anchor:"accelerate.Accelerator.prepare_model",parameters:[{name:"model",val:": Module"},{name:"device_placement",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare_model.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
A PyTorch model to prepare. You don&#x2019;t need to prepare a model if it is used only for inference without
any kind of mixed precision`,name:"model"},{anchor:"accelerate.Accelerator.prepare_model.device_placement",description:`<strong>device_placement</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to place the model on the proper device. Will default to <code>self.device_placement</code>.`,name:"device_placement"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L925"}}),kr=new P({props:{name:"prepare_optimizer",anchor:"accelerate.Accelerator.prepare_optimizer",parameters:[{name:"optimizer",val:": Optimizer"},{name:"device_placement",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare_optimizer.optimizer",description:`<strong>optimizer</strong> (<code>torch.optim.Optimizer</code>) &#x2014;
A vanilla PyTorch optimizer to prepare`,name:"optimizer"},{anchor:"accelerate.Accelerator.prepare_optimizer.device_placement",description:`<strong>device_placement</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to place the optimizer on the proper device. Will default to <code>self.device_placement</code>.`,name:"device_placement"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1286"}}),jr=new P({props:{name:"prepare_scheduler",anchor:"accelerate.Accelerator.prepare_scheduler",parameters:[{name:"scheduler",val:": _LRScheduler"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare_scheduler.scheduler",description:`<strong>scheduler</strong> (<code>torch.optim.lr_scheduler.LRScheduler</code>) &#x2014;
A vanilla PyTorch scheduler to prepare`,name:"scheduler"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1303"}}),Dr=new P({props:{name:"print",anchor:"accelerate.Accelerator.print",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L757"}}),zr=new P({props:{name:"reduce",anchor:"accelerate.Accelerator.reduce",parameters:[{name:"tensor",val:""},{name:"reduction",val:" = 'sum'"}],parametersDescription:[{anchor:"accelerate.Accelerator.reduce.tensor",description:`<strong>tensor</strong> (<code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code>) &#x2014;
The tensors to reduce across all processes.`,name:"tensor"},{anchor:"accelerate.Accelerator.reduce.reduction",description:`<strong>reduction</strong> (<code>str</code>, <em>optional</em>, defaults to &#x201C;sum&#x201D;) &#x2014;
A reduction type, can be one of &#x2018;sum&#x2019;, &#x2018;mean&#x2019;, or &#x2018;none&#x2019;. If &#x2018;none&#x2019;, will not perform any operation.`,name:"reduction"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1481",returnDescription:`
<p>The reduced tensor(s).</p>
`,returnType:`
<p><code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code></p>
`}}),Or=new P({props:{name:"register_for_checkpointing",anchor:"accelerate.Accelerator.register_for_checkpointing",parameters:[{name:"*objects",val:""}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1948"}}),Zt=new fe({props:{$$slots:{default:[Nb]},$$scope:{ctx:D}}}),Ir=new P({props:{name:"register_load_state_pre_hook",anchor:"accelerate.Accelerator.register_load_state_pre_hook",parameters:[{name:"hook",val:": typing.Callable[..., NoneType]"}],parametersDescription:[{anchor:"accelerate.Accelerator.register_load_state_pre_hook.hook",description:`<strong>hook</strong> (<code>Callable</code>) &#x2014;
A function to be called in <a href="/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.load_state">Accelerator.load_state()</a> before <code>load_checkpoint</code>.`,name:"hook"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1756",returnDescription:`
<p>a handle that can be used to remove the added hook by calling
<code>handle.remove()</code></p>
`,returnType:`
<p><code>torch.utils.hooks.RemovableHandle</code></p>
`}}),ea=new fe({props:{$$slots:{default:[qb]},$$scope:{ctx:D}}}),Sr=new P({props:{name:"register_save_state_pre_hook",anchor:"accelerate.Accelerator.register_save_state_pre_hook",parameters:[{name:"hook",val:": typing.Callable[..., NoneType]"}],parametersDescription:[{anchor:"accelerate.Accelerator.register_save_state_pre_hook.hook",description:`<strong>hook</strong> (<code>Callable</code>) &#x2014;
A function to be called in <a href="/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.save_state">Accelerator.save_state()</a> before <code>save_checkpoint</code>.`,name:"hook"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1625",returnDescription:`
<p>a handle that can be used to remove the added hook by calling
<code>handle.remove()</code></p>
`,returnType:`
<p><code>torch.utils.hooks.RemovableHandle</code></p>
`}}),ta=new fe({props:{$$slots:{default:[Ub]},$$scope:{ctx:D}}}),Lr=new P({props:{name:"save",anchor:"accelerate.Accelerator.save",parameters:[{name:"obj",val:""},{name:"f",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.save.f",description:`<strong>f</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Where to save the content of <code>obj</code>.`,name:"f"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1614"}}),Nr=new P({props:{name:"save_state",anchor:"accelerate.Accelerator.save_state",parameters:[{name:"output_dir",val:": str = None"},{name:"**save_model_func_kwargs",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.save_state.output_dir",description:`<strong>output_dir</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
The name of the folder to save all relevant weights and states.`,name:"output_dir"},{anchor:"accelerate.Accelerator.save_state.save_model_func_kwargs",description:`<strong>save_model_func_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Additional keyword arguments for saving model which can be passed to the underlying save function, such
as optional arguments for DeepSpeed&#x2019;s <code>save_checkpoint</code> function.`,name:"save_model_func_kwargs"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1657"}}),ra=new fe({props:{$$slots:{default:[Rb]},$$scope:{ctx:D}}}),Ur=new P({props:{name:"unscale_gradients",anchor:"accelerate.Accelerator.unscale_gradients",parameters:[{name:"optimizer",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.unscale_gradients.optimizer",description:`<strong>optimizer</strong> (<code>torch.optim.Optimizer</code> or <code>List[torch.optim.Optimizer]</code>, <em>optional</em>) &#x2014;
The optimizer(s) for which to unscale gradients. If not set, will unscale gradients on all optimizers
that were passed to <a href="/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare">prepare()</a>.`,name:"optimizer"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1346"}}),Rr=new P({props:{name:"unwrap_model",anchor:"accelerate.Accelerator.unwrap_model",parameters:[{name:"model",val:""},{name:"keep_fp32_wrapper",val:": bool = False"}],parametersDescription:[{anchor:"accelerate.Accelerator.unwrap_model.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
The model to unwrap.`,name:"model"},{anchor:"accelerate.Accelerator.unwrap_model.keep_fp32_wrapper",description:`<strong>keep_fp32_wrapper</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to not remove the mixed precision hook if it was added.`,name:"keep_fp32_wrapper"}],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1516"}}),Mr=new P({props:{name:"wait_for_everyone",anchor:"accelerate.Accelerator.wait_for_everyone",parameters:[],source:"https://github.com/huggingface/accelerate/blob/main/src/accelerate/accelerator.py#L1529"}}),{c(){d=n("meta"),x=l(),u=n("h1"),g=n("a"),j=n("span"),$(h.$$.fragment),k=l(),z=n("span"),ge=r("Accelerator"),Ve=l(),H=n("p"),_e=r("The "),S=n("a"),Fr=r("Accelerator"),Hr=r(` is the main class provided by \u{1F917} Accelerate.
It serves at the main entrypoint for the API.`),ha=l(),ve=n("h2"),Ge=n("a"),Co=n("span"),$(ma.$$.fragment),Di=l(),No=n("span"),Ti=r("Quick adaptation of your code"),zc=l(),Yr=n("p"),zi=r("To quickly adapt your script to work on any kind of setup with \u{1F917} Accelerate just:"),Oc=l(),te=n("ol"),$e=n("li"),Oi=r("Initialize an "),Br=n("a"),Ii=r("Accelerator"),Si=r(" object (that we will call "),qo=n("code"),Li=r("accelerator"),Ci=r(" throughout this page) as early as possible in your script."),Ni=l(),ua=n("li"),qi=r("Pass your dataloader(s), model(s), optimizer(s), and scheduler(s) to the "),Jr=n("a"),Ui=r("prepare()"),Ri=r(" method."),Mi=l(),X=n("li"),Vi=r("Remove all the "),Uo=n("code"),Gi=r(".cuda()"),Wi=r(" or "),Ro=n("code"),Fi=r(".to(device)"),Hi=r(" from your code and let the "),Mo=n("code"),Yi=r("accelerator"),Bi=r(" handle the device placement for you."),Ic=l(),$(We.$$.fragment),Sc=l(),be=n("ol"),Fe=n("li"),Ji=r("Replace "),Vo=n("code"),Ki=r("loss.backward()"),Qi=r(" in your code with "),Go=n("code"),Xi=r("accelerator.backward(loss)"),Zi=l(),Kr=n("li"),ed=r("Gather your predictions and labels before storing them or using them for metric computation using "),Qr=n("a"),td=r("gather()"),Lc=l(),$(He.$$.fragment),Cc=l(),Ye=n("p"),ad=r(`In most cases this is all that is needed. The next section lists a few more advanced use cases and nice features
you should search for and replace by the corresponding methods of your `),Wo=n("code"),rd=r("accelerator"),od=r(":"),Nc=l(),ye=n("h2"),Be=n("a"),Fo=n("span"),$(fa.$$.fragment),nd=l(),Ho=n("span"),sd=r("Advanced recommendations"),qc=l(),we=n("h3"),Je=n("a"),Yo=n("span"),$(ga.$$.fragment),cd=l(),Bo=n("span"),ld=r("Printing"),Uc=l(),Ee=n("p"),Jo=n("code"),id=r("print"),dd=r(" statements should be replaced by "),Xr=n("a"),pd=r("print()"),hd=r(" to be printed once per process"),Rc=l(),$(_a.$$.fragment),Mc=l(),Ae=n("h3"),Ke=n("a"),Ko=n("span"),$(va.$$.fragment),md=l(),Qo=n("span"),ud=r("Executing processes"),Vc=l(),ke=n("h4"),Qe=n("a"),Xo=n("span"),$($a.$$.fragment),fd=l(),Zo=n("span"),gd=r("Once on a single server"),Gc=l(),Xe=n("p"),_d=r("For statements that should be executed once per server, use "),en=n("code"),vd=r("is_local_main_process"),$d=r(":"),Wc=l(),$(ba.$$.fragment),Fc=l(),Ze=n("p"),bd=r("A function can be wrapped using the "),Zr=n("a"),yd=r("on_local_main_process()"),wd=r(` function to achieve the same
behavior on a function\u2019s execution:`),Hc=l(),$(ya.$$.fragment),Yc=l(),xe=n("h4"),et=n("a"),tn=n("span"),$(wa.$$.fragment),Ed=l(),an=n("span"),Ad=r("Only ever once across all servers"),Bc=l(),tt=n("p"),kd=r("For statements that should only ever be executed once, use "),rn=n("code"),xd=r("is_main_process"),jd=r(":"),Jc=l(),$(Ea.$$.fragment),Kc=l(),at=n("p"),Pd=r("A function can be wrapped using the "),eo=n("a"),Dd=r("on_main_process()"),Td=r(` function to achieve the same
behavior on a function\u2019s execution:`),Qc=l(),$(Aa.$$.fragment),Xc=l(),je=n("h4"),rt=n("a"),on=n("span"),$(ka.$$.fragment),zd=l(),nn=n("span"),Od=r("On specific processes"),Zc=l(),to=n("p"),Id=r(`If a function should be ran on a specific overall or local process index, there are similar decorators
to achieve this:`),el=l(),$(xa.$$.fragment),tl=l(),$(ja.$$.fragment),al=l(),Pe=n("h3"),ot=n("a"),sn=n("span"),$(Pa.$$.fragment),Sd=l(),cn=n("span"),Ld=r("Synchronicity control"),rl=l(),nt=n("p"),Cd=r("Use "),ao=n("a"),Nd=r("wait_for_everyone()"),qd=r(" to make sure all processes join that point before continuing. (Useful before a model save for instance)"),ol=l(),De=n("h3"),st=n("a"),ln=n("span"),$(Da.$$.fragment),Ud=l(),dn=n("span"),Rd=r("Saving and loading"),nl=l(),ct=n("p"),Md=r("Use "),ro=n("a"),Vd=r("unwrap_model()"),Gd=r(" before saving to remove all special model wrappers added during the distributed process."),sl=l(),$(Ta.$$.fragment),cl=l(),ae=n("p"),Wd=r("Use "),oo=n("a"),Fd=r("save()"),Hd=r(" instead of "),pn=n("code"),Yd=r("torch.save"),Bd=r(":"),ll=l(),$(za.$$.fragment),il=l(),Te=n("h3"),lt=n("a"),hn=n("span"),$(Oa.$$.fragment),Jd=l(),mn=n("span"),Kd=r("Operations"),dl=l(),W=n("p"),Qd=r("Use "),it=n("a"),Xd=r("clip"),un=n("em"),Zd=r("grad_norm"),ep=r("()"),tp=r(" instead of "),fn=n("code"),ap=r("torch.nn.utils.clip_grad_norm_"),rp=r(" and "),dt=n("a"),op=r("clip"),gn=n("em"),np=r("grad_value"),sp=r("()"),cp=r(" instead of "),_n=n("code"),lp=r("torch.nn.utils.clip_grad_value"),pl=l(),ze=n("h3"),pt=n("a"),vn=n("span"),$(Ia.$$.fragment),ip=l(),$n=n("span"),dp=r("Gradient Accumulation"),hl=l(),ht=n("p"),pp=r("To perform gradient accumulation use "),no=n("a"),hp=r("accumulate()"),mp=r(` and specify a gradient_accumulation_steps.
This will also automatically ensure the gradients are synced or unsynced when on
multi-device training, check if the step should actually be performed, and auto-scale the loss:`),ml=l(),$(Sa.$$.fragment),ul=l(),Oe=n("h2"),mt=n("a"),bn=n("span"),$(La.$$.fragment),up=l(),yn=n("span"),fp=r("Overall API documentation:"),fl=l(),f=n("div"),$(Ca.$$.fragment),gp=l(),wn=n("p"),_p=r("Creates an instance of an accelerator for distributed training (on multi-GPU, TPU) or mixed precision training."),vp=l(),En=n("p"),An=n("strong"),$p=r("Available attributes:"),bp=l(),T=n("ul"),ut=n("li"),kn=n("strong"),yp=r("device"),wp=r(" ("),xn=n("code"),Ep=r("torch.device"),Ap=r(") \u2014 The device to use."),kp=l(),ft=n("li"),jn=n("strong"),xp=r("distributed_type"),jp=r(" ("),so=n("a"),Pp=r("DistributedType"),Dp=r(") \u2014 The distributed training configuration."),Tp=l(),gt=n("li"),Pn=n("strong"),zp=r("local_process_index"),Op=r(" ("),Dn=n("code"),Ip=r("int"),Sp=r(") \u2014 The process index on the current machine."),Lp=l(),_t=n("li"),Tn=n("strong"),Cp=r("mixed_precision"),Np=r(" ("),zn=n("code"),qp=r("str"),Up=r(") \u2014 The configured mixed precision mode."),Rp=l(),vt=n("li"),On=n("strong"),Mp=r("num_processes"),Vp=r(" ("),In=n("code"),Gp=r("int"),Wp=r(") \u2014 The total number of processes used for training."),Fp=l(),$t=n("li"),Sn=n("strong"),Hp=r("optimizer_step_was_skipped"),Yp=r(" ("),Ln=n("code"),Bp=r("bool"),Jp=r(`) \u2014 Whether or not the optimizer update was skipped (because of
gradient overflow in mixed precision), in which
case the learning rate should not be changed.`),Kp=l(),bt=n("li"),Cn=n("strong"),Qp=r("process_index"),Xp=r(" ("),Nn=n("code"),Zp=r("int"),eh=r(") \u2014 The overall index of the current process among all processes."),th=l(),yt=n("li"),qn=n("strong"),ah=r("state"),rh=r(" ("),co=n("a"),oh=r("AcceleratorState"),nh=r(") \u2014 The distributed setup state."),sh=l(),wt=n("li"),Un=n("strong"),ch=r("sync_gradients"),lh=r(" ("),Rn=n("code"),ih=r("bool"),dh=r(") \u2014 Whether the gradients are currently being synced across all processes."),ph=l(),Et=n("li"),Mn=n("strong"),hh=r("use_distributed"),mh=r(" ("),Vn=n("code"),uh=r("bool"),fh=r(") \u2014 Whether the current configuration is for distributed training."),gh=l(),re=n("div"),$(Na.$$.fragment),_h=l(),Gn=n("p"),vh=r("A context manager that will lightly wrap around and perform gradient accumulation automatically"),$h=l(),$(At.$$.fragment),bh=l(),kt=n("div"),$(qa.$$.fragment),yh=l(),Wn=n("p"),wh=r(`Will apply automatic mixed-precision inside the block inside this context manager, if it is enabled. Nothing
different will happen otherwise.`),Eh=l(),oe=n("div"),$(Ua.$$.fragment),Ah=l(),Ie=n("p"),kh=r("Scales the gradients in accordance to "),Fn=n("code"),xh=r("Accelerator.gradient_accumulation_steps"),jh=r(` and calls the correct
`),Hn=n("code"),Ph=r("backward()"),Dh=r(" based on the configuration."),Th=l(),Ra=n("p"),zh=r("Should be used in lieu of "),Yn=n("code"),Oh=r("loss.backward()"),Ih=r("."),Sh=l(),xt=n("div"),$(Ma.$$.fragment),Lh=l(),Va=n("p"),Ch=r("Alias for "),Bn=n("code"),Nh=r("Accelerate.free_memory"),qh=r(`, releases all references to the internal objects stored and call the
garbage collector. You should call this method between two trainings with different models/optimizers.`),Uh=l(),ne=n("div"),$(Ga.$$.fragment),Rh=l(),Wa=n("p"),Mh=r("Should be used in place of "),Jn=n("code"),Vh=r("torch.nn.utils.clip_grad_norm_"),Gh=r("."),Wh=l(),$(jt.$$.fragment),Fh=l(),se=n("div"),$(Fa.$$.fragment),Hh=l(),Ha=n("p"),Yh=r("Should be used in place of "),Kn=n("code"),Bh=r("torch.nn.utils.clip_grad_value_"),Jh=r("."),Kh=l(),$(Pt.$$.fragment),Qh=l(),Dt=n("div"),$(Ya.$$.fragment),Xh=l(),Qn=n("p"),Zh=r(`Runs any special end training behaviors, such as stopping trackers on the main process only. Should always be
called at the end of your script if using experiment tracking.`),em=l(),Tt=n("div"),$(Ba.$$.fragment),tm=l(),Xn=n("p"),am=r(`Will release all references to the internal objects stored and call the garbage collector. You should call this
method between two trainings with different models/optimizers.`),rm=l(),ce=n("div"),$(Ja.$$.fragment),om=l(),Ka=n("p"),nm=r("Gather the values in "),Zn=n("em"),sm=r("tensor"),cm=r(` across all processes and concatenate them on the first dimension. Useful to
regroup the predictions from all processes when doing evaluation.`),lm=l(),es=n("p"),im=r(`Note:
This gather happens in all processes.`),dm=l(),zt=n("div"),$(Qa.$$.fragment),pm=l(),Xa=n("p"),hm=r("Gathers "),ts=n("code"),mm=r("tensor"),um=r(` and potentially drops duplicates in the last batch if on a distributed system. Should be used
for gathering the inputs and targets for metric calculation.`),fm=l(),Ot=n("div"),$(Za.$$.fragment),gm=l(),er=n("p"),_m=r("Returns the state dictionary of a model sent through "),lo=n("a"),vm=r("Accelerator.prepare()"),$m=r(" in full precision"),bm=l(),It=n("div"),$(tr.$$.fragment),ym=l(),Z=n("p"),wm=r("Returns a "),as=n("code"),Em=r("tracker"),Am=r(" from "),rs=n("code"),km=r("self.trackers"),xm=r(" based on "),os=n("code"),jm=r("name"),Pm=r(" on the main process only."),Dm=l(),St=n("div"),$(ar.$$.fragment),Tm=l(),rr=n("p"),zm=r("Initializes a run for all trackers stored in "),ns=n("code"),Om=r("self.log_with"),Im=r(", potentially with starting configurations"),Sm=l(),M=n("div"),$(or.$$.fragment),Lm=l(),nr=n("p"),Cm=r(`A context manager that facilitates distributed training or evaluation on uneven inputs, which acts as a wrapper
around `),ss=n("code"),Nm=r("torch.distributed.algorithms.join"),qm=r(`. This is useful when the total batch size does not evenly divide the
length of the dataset.`),Um=l(),$(Lt.$$.fragment),Rm=l(),$(Ct.$$.fragment),Mm=l(),$(Nt.$$.fragment),Vm=l(),le=n("div"),$(sr.$$.fragment),Gm=l(),cs=n("p"),Wm=r("Loads the current states of the model, optimizer, scaler, RNG generators, and registered objects."),Fm=l(),$(qt.$$.fragment),Hm=l(),ie=n("div"),$(cr.$$.fragment),Ym=l(),ls=n("p"),Bm=r("Lets the local main process go inside a with block."),Jm=l(),is=n("p"),Km=r("The other processes will enter the with block after the main process exits."),Qm=l(),Ut=n("div"),$(lr.$$.fragment),Xm=l(),Se=n("p"),Zm=r("Logs "),ds=n("code"),eu=r("values"),tu=r(" to all stored trackers in "),ps=n("code"),au=r("self.trackers"),ru=r(" on the main process only."),ou=l(),de=n("div"),$(ir.$$.fragment),nu=l(),hs=n("p"),su=r("Lets the main process go first inside a with block."),cu=l(),ms=n("p"),lu=r("The other processes will enter the with block after the main process exits."),iu=l(),Y=n("div"),$(dr.$$.fragment),du=l(),pr=n("p"),pu=r(`A context manager to disable gradient synchronizations across DDP processes by calling
`),us=n("code"),hu=r("torch.nn.parallel.DistributedDataParallel.no_sync"),mu=r("."),uu=l(),hr=n("p"),fu=r("If "),fs=n("code"),gu=r("model"),_u=r(" is not in DDP, this context manager does nothing"),vu=l(),$(Rt.$$.fragment),$u=l(),Mt=n("div"),$(mr.$$.fragment),bu=l(),gs=n("p"),yu=r("A decorator that will run the decorated function on the last process only."),wu=l(),Vt=n("div"),$(ur.$$.fragment),Eu=l(),_s=n("p"),Au=r("A decorator that will run the decorated function on the local main process only."),ku=l(),Gt=n("div"),$(fr.$$.fragment),xu=l(),vs=n("p"),ju=r("A decorator that will run the decorated function on a given local process index only."),Pu=l(),Wt=n("div"),$(gr.$$.fragment),Du=l(),$s=n("p"),Tu=r("A decorator that will run the decorated function on the main process only."),zu=l(),Ft=n("div"),$(_r.$$.fragment),Ou=l(),bs=n("p"),Iu=r("A decorator that will run the decorated function on a given process index only."),Su=l(),Ht=n("div"),$(vr.$$.fragment),Lu=l(),ys=n("p"),Cu=r(`Recursively pad the tensors in a nested list/tuple/dictionary of tensors from all devices to the same size so
they can safely be gathered.`),Nu=l(),pe=n("div"),$($r.$$.fragment),qu=l(),br=n("p"),Uu=r("Prepare all objects passed in "),ws=n("code"),Ru=r("args"),Mu=r(` for distributed training and mixed precision, then return them in the same
order.`),Vu=l(),$(Yt.$$.fragment),Gu=l(),Bt=n("div"),$(yr.$$.fragment),Wu=l(),wr=n("p"),Fu=r(`Prepares a PyTorch DataLoader for training in any distributed setup. It is recommended to use
`),io=n("a"),Hu=r("Accelerator.prepare()"),Yu=r(" instead."),Bu=l(),Jt=n("div"),$(Er.$$.fragment),Ju=l(),Ar=n("p"),Ku=r(`Prepares a PyTorch model for training in any distributed setup. It is recommended to use
`),po=n("a"),Qu=r("Accelerator.prepare()"),Xu=r(" instead."),Zu=l(),Kt=n("div"),$(kr.$$.fragment),ef=l(),xr=n("p"),tf=r(`Prepares a PyTorch Optimizer for training in any distributed setup. It is recommended to use
`),ho=n("a"),af=r("Accelerator.prepare()"),rf=r(" instead."),of=l(),Qt=n("div"),$(jr.$$.fragment),nf=l(),Pr=n("p"),sf=r(`Prepares a PyTorch Scheduler for training in any distributed setup. It is recommended to use
`),mo=n("a"),cf=r("Accelerator.prepare()"),lf=r(" instead."),df=l(),Xt=n("div"),$(Dr.$$.fragment),pf=l(),Tr=n("p"),hf=r("Use in replacement of "),Es=n("code"),mf=r("print()"),uf=r(" to only print once per server."),ff=l(),he=n("div"),$(zr.$$.fragment),gf=l(),Le=n("p"),_f=r("Reduce the values in "),As=n("em"),vf=r("tensor"),$f=r(" across all processes based on "),ks=n("em"),bf=r("reduction"),yf=r("."),wf=l(),xs=n("p"),Ef=r(`Note:
All processes get the reduced value.`),Af=l(),B=n("div"),$(Or.$$.fragment),kf=l(),ee=n("p"),xf=r("Makes note of "),js=n("code"),jf=r("objects"),Pf=r(" and will save or load them in during "),Ps=n("code"),Df=r("save_state"),Tf=r(" or "),Ds=n("code"),zf=r("load_state"),Of=r("."),If=l(),Ts=n("p"),Sf=r(`These should be utilized when the state is being loaded or saved in the same script. It is not designed to be
used in different scripts`),Lf=l(),$(Zt.$$.fragment),Cf=l(),C=n("div"),$(Ir.$$.fragment),Nf=l(),Ce=n("p"),qf=r("Registers a pre hook to be run before "),zs=n("code"),Uf=r("load_checkpoint"),Rf=r(" is called in "),uo=n("a"),Mf=r("Accelerator.load_state()"),Vf=r("."),Gf=l(),Os=n("p"),Wf=r("The hook should have the following signature:"),Ff=l(),Is=n("p"),Ss=n("code"),Hf=r("hook(models: List[torch.nn.Module], input_dir: str) -> None"),Yf=l(),U=n("p"),Bf=r("The "),Ls=n("code"),Jf=r("models"),Kf=r(" argument are the models as saved in the accelerator state under "),Cs=n("code"),Qf=r("accelerator._models"),Xf=r(`, and the
`),Ns=n("code"),Zf=r("input_dir"),eg=r(" argument is the "),qs=n("code"),tg=r("input_dir"),ag=r(" argument passed to "),fo=n("a"),rg=r("Accelerator.load_state()"),og=r("."),ng=l(),$(ea.$$.fragment),sg=l(),N=n("div"),$(Sr.$$.fragment),cg=l(),Ne=n("p"),lg=r("Registers a pre hook to be run before "),Us=n("code"),ig=r("save_checkpoint"),dg=r(" is called in "),go=n("a"),pg=r("Accelerator.save_state()"),hg=r("."),mg=l(),Rs=n("p"),ug=r("The hook should have the following signature:"),fg=l(),Ms=n("p"),Vs=n("code"),gg=r("hook(models: List[torch.nn.Module], weights: List[Dict[str, torch.Tensor]], input_dir: str) -> None"),_g=l(),I=n("p"),vg=r("The "),Gs=n("code"),$g=r("models"),bg=r(" argument are the models as saved in the accelerator state under "),Ws=n("code"),yg=r("accelerator._models"),wg=r(", "),Fs=n("code"),Eg=r("weigths"),Ag=r(`
argument are the state dicts of the `),Hs=n("code"),kg=r("models"),xg=r(", and the "),Ys=n("code"),jg=r("input_dir"),Pg=r(" argument is the "),Bs=n("code"),Dg=r("input_dir"),Tg=r(` argument passed
to `),_o=n("a"),zg=r("Accelerator.load_state()"),Og=r("."),Ig=l(),$(ta.$$.fragment),Sg=l(),aa=n("div"),$(Lr.$$.fragment),Lg=l(),Cr=n("p"),Cg=r("Save the object passed to disk once per machine. Use in place of "),Js=n("code"),Ng=r("torch.save"),qg=r("."),Ug=l(),V=n("div"),$(Nr.$$.fragment),Rg=l(),Ks=n("p"),Mg=r("Saves the current states of the model, optimizer, scaler, RNG generators, and registered objects to a folder."),Vg=l(),L=n("p"),Gg=r("If a "),Qs=n("code"),Wg=r("ProjectConfiguration"),Fg=r(" was passed to the "),Xs=n("code"),Hg=r("Accelerator"),Yg=r(" object with "),Zs=n("code"),Bg=r("automatic_checkpoint_naming"),Jg=r(` enabled
then checkpoints will be saved to `),ec=n("code"),Kg=r("self.project_dir/checkpoints"),Qg=r(`. If the number of current saves is greater
than `),tc=n("code"),Xg=r("total_limit"),Zg=r(` then the oldest save is deleted. Each checkpoint is saved in seperate folders named
`),ac=n("code"),e_=r("checkpoint_<iteration>"),t_=r("."),a_=l(),qr=n("p"),r_=r("Otherwise they are just saved to "),rc=n("code"),o_=r("output_dir"),n_=r("."),s_=l(),$(ra.$$.fragment),c_=l(),oa=n("div"),$(Ur.$$.fragment),l_=l(),oc=n("p"),i_=r("Unscale the gradients in mixed precision training with AMP. This is a noop in all other settings."),d_=l(),na=n("div"),$(Rr.$$.fragment),p_=l(),qe=n("p"),h_=r("Unwraps the "),nc=n("code"),m_=r("model"),u_=r(" from the additional layer possible added by "),vo=n("a"),f_=r("prepare()"),g_=r(`. Useful before saving
the model.`),__=l(),sa=n("div"),$(Mr.$$.fragment),v_=l(),sc=n("p"),$_=r(`Will stop the execution of the current process until every other process has reached that point (so this does
nothing when the script is only run in one process). Useful to do before saving a model.`),this.h()},l(t){const m=Ab('[data-svelte="svelte-1phssyn"]',document.head);d=s(m,"META",{name:!0,content:!0}),m.forEach(a),x=i(t),u=s(t,"H1",{class:!0});var Vr=c(u);g=s(Vr,"A",{id:!0,class:!0,href:!0});var cc=c(g);j=s(cc,"SPAN",{});var lc=c(j);b(h.$$.fragment,lc),lc.forEach(a),cc.forEach(a),k=i(Vr),z=s(Vr,"SPAN",{});var ic=c(z);ge=o(ic,"Accelerator"),ic.forEach(a),Vr.forEach(a),Ve=i(t),H=s(t,"P",{});var Gr=c(H);_e=o(Gr,"The "),S=s(Gr,"A",{href:!0});var dc=c(S);Fr=o(dc,"Accelerator"),dc.forEach(a),Hr=o(Gr,` is the main class provided by \u{1F917} Accelerate.
It serves at the main entrypoint for the API.`),Gr.forEach(a),ha=i(t),ve=s(t,"H2",{class:!0});var Wr=c(ve);Ge=s(Wr,"A",{id:!0,class:!0,href:!0});var pc=c(Ge);Co=s(pc,"SPAN",{});var hc=c(Co);b(ma.$$.fragment,hc),hc.forEach(a),pc.forEach(a),Di=i(Wr),No=s(Wr,"SPAN",{});var mc=c(No);Ti=o(mc,"Quick adaptation of your code"),mc.forEach(a),Wr.forEach(a),zc=i(t),Yr=s(t,"P",{});var uc=c(Yr);zi=o(uc,"To quickly adapt your script to work on any kind of setup with \u{1F917} Accelerate just:"),uc.forEach(a),Oc=i(t),te=s(t,"OL",{});var Ue=c(te);$e=s(Ue,"LI",{});var Re=c($e);Oi=o(Re,"Initialize an "),Br=s(Re,"A",{href:!0});var fc=c(Br);Ii=o(fc,"Accelerator"),fc.forEach(a),Si=o(Re," object (that we will call "),qo=s(Re,"CODE",{});var gc=c(qo);Li=o(gc,"accelerator"),gc.forEach(a),Ci=o(Re," throughout this page) as early as possible in your script."),Re.forEach(a),Ni=i(Ue),ua=s(Ue,"LI",{});var _l=c(ua);qi=o(_l,"Pass your dataloader(s), model(s), optimizer(s), and scheduler(s) to the "),Jr=s(_l,"A",{href:!0});var y_=c(Jr);Ui=o(y_,"prepare()"),y_.forEach(a),Ri=o(_l," method."),_l.forEach(a),Mi=i(Ue),X=s(Ue,"LI",{});var ca=c(X);Vi=o(ca,"Remove all the "),Uo=s(ca,"CODE",{});var w_=c(Uo);Gi=o(w_,".cuda()"),w_.forEach(a),Wi=o(ca," or "),Ro=s(ca,"CODE",{});var E_=c(Ro);Fi=o(E_,".to(device)"),E_.forEach(a),Hi=o(ca," from your code and let the "),Mo=s(ca,"CODE",{});var A_=c(Mo);Yi=o(A_,"accelerator"),A_.forEach(a),Bi=o(ca," handle the device placement for you."),ca.forEach(a),Ue.forEach(a),Ic=i(t),b(We.$$.fragment,t),Sc=i(t),be=s(t,"OL",{start:!0});var vl=c(be);Fe=s(vl,"LI",{});var _c=c(Fe);Ji=o(_c,"Replace "),Vo=s(_c,"CODE",{});var k_=c(Vo);Ki=o(k_,"loss.backward()"),k_.forEach(a),Qi=o(_c," in your code with "),Go=s(_c,"CODE",{});var x_=c(Go);Xi=o(x_,"accelerator.backward(loss)"),x_.forEach(a),_c.forEach(a),Zi=i(vl),Kr=s(vl,"LI",{});var b_=c(Kr);ed=o(b_,"Gather your predictions and labels before storing them or using them for metric computation using "),Qr=s(b_,"A",{href:!0});var j_=c(Qr);td=o(j_,"gather()"),j_.forEach(a),b_.forEach(a),vl.forEach(a),Lc=i(t),b(He.$$.fragment,t),Cc=i(t),Ye=s(t,"P",{});var $l=c(Ye);ad=o($l,`In most cases this is all that is needed. The next section lists a few more advanced use cases and nice features
you should search for and replace by the corresponding methods of your `),Wo=s($l,"CODE",{});var P_=c(Wo);rd=o(P_,"accelerator"),P_.forEach(a),od=o($l,":"),$l.forEach(a),Nc=i(t),ye=s(t,"H2",{class:!0});var bl=c(ye);Be=s(bl,"A",{id:!0,class:!0,href:!0});var D_=c(Be);Fo=s(D_,"SPAN",{});var T_=c(Fo);b(fa.$$.fragment,T_),T_.forEach(a),D_.forEach(a),nd=i(bl),Ho=s(bl,"SPAN",{});var z_=c(Ho);sd=o(z_,"Advanced recommendations"),z_.forEach(a),bl.forEach(a),qc=i(t),we=s(t,"H3",{class:!0});var yl=c(we);Je=s(yl,"A",{id:!0,class:!0,href:!0});var O_=c(Je);Yo=s(O_,"SPAN",{});var I_=c(Yo);b(ga.$$.fragment,I_),I_.forEach(a),O_.forEach(a),cd=i(yl),Bo=s(yl,"SPAN",{});var S_=c(Bo);ld=o(S_,"Printing"),S_.forEach(a),yl.forEach(a),Uc=i(t),Ee=s(t,"P",{});var vc=c(Ee);Jo=s(vc,"CODE",{});var L_=c(Jo);id=o(L_,"print"),L_.forEach(a),dd=o(vc," statements should be replaced by "),Xr=s(vc,"A",{href:!0});var C_=c(Xr);pd=o(C_,"print()"),C_.forEach(a),hd=o(vc," to be printed once per process"),vc.forEach(a),Rc=i(t),b(_a.$$.fragment,t),Mc=i(t),Ae=s(t,"H3",{class:!0});var wl=c(Ae);Ke=s(wl,"A",{id:!0,class:!0,href:!0});var N_=c(Ke);Ko=s(N_,"SPAN",{});var q_=c(Ko);b(va.$$.fragment,q_),q_.forEach(a),N_.forEach(a),md=i(wl),Qo=s(wl,"SPAN",{});var U_=c(Qo);ud=o(U_,"Executing processes"),U_.forEach(a),wl.forEach(a),Vc=i(t),ke=s(t,"H4",{class:!0});var El=c(ke);Qe=s(El,"A",{id:!0,class:!0,href:!0});var R_=c(Qe);Xo=s(R_,"SPAN",{});var M_=c(Xo);b($a.$$.fragment,M_),M_.forEach(a),R_.forEach(a),fd=i(El),Zo=s(El,"SPAN",{});var V_=c(Zo);gd=o(V_,"Once on a single server"),V_.forEach(a),El.forEach(a),Gc=i(t),Xe=s(t,"P",{});var Al=c(Xe);_d=o(Al,"For statements that should be executed once per server, use "),en=s(Al,"CODE",{});var G_=c(en);vd=o(G_,"is_local_main_process"),G_.forEach(a),$d=o(Al,":"),Al.forEach(a),Wc=i(t),b(ba.$$.fragment,t),Fc=i(t),Ze=s(t,"P",{});var kl=c(Ze);bd=o(kl,"A function can be wrapped using the "),Zr=s(kl,"A",{href:!0});var W_=c(Zr);yd=o(W_,"on_local_main_process()"),W_.forEach(a),wd=o(kl,` function to achieve the same
behavior on a function\u2019s execution:`),kl.forEach(a),Hc=i(t),b(ya.$$.fragment,t),Yc=i(t),xe=s(t,"H4",{class:!0});var xl=c(xe);et=s(xl,"A",{id:!0,class:!0,href:!0});var F_=c(et);tn=s(F_,"SPAN",{});var H_=c(tn);b(wa.$$.fragment,H_),H_.forEach(a),F_.forEach(a),Ed=i(xl),an=s(xl,"SPAN",{});var Y_=c(an);Ad=o(Y_,"Only ever once across all servers"),Y_.forEach(a),xl.forEach(a),Bc=i(t),tt=s(t,"P",{});var jl=c(tt);kd=o(jl,"For statements that should only ever be executed once, use "),rn=s(jl,"CODE",{});var B_=c(rn);xd=o(B_,"is_main_process"),B_.forEach(a),jd=o(jl,":"),jl.forEach(a),Jc=i(t),b(Ea.$$.fragment,t),Kc=i(t),at=s(t,"P",{});var Pl=c(at);Pd=o(Pl,"A function can be wrapped using the "),eo=s(Pl,"A",{href:!0});var J_=c(eo);Dd=o(J_,"on_main_process()"),J_.forEach(a),Td=o(Pl,` function to achieve the same
behavior on a function\u2019s execution:`),Pl.forEach(a),Qc=i(t),b(Aa.$$.fragment,t),Xc=i(t),je=s(t,"H4",{class:!0});var Dl=c(je);rt=s(Dl,"A",{id:!0,class:!0,href:!0});var K_=c(rt);on=s(K_,"SPAN",{});var Q_=c(on);b(ka.$$.fragment,Q_),Q_.forEach(a),K_.forEach(a),zd=i(Dl),nn=s(Dl,"SPAN",{});var X_=c(nn);Od=o(X_,"On specific processes"),X_.forEach(a),Dl.forEach(a),Zc=i(t),to=s(t,"P",{});var Z_=c(to);Id=o(Z_,`If a function should be ran on a specific overall or local process index, there are similar decorators
to achieve this:`),Z_.forEach(a),el=i(t),b(xa.$$.fragment,t),tl=i(t),b(ja.$$.fragment,t),al=i(t),Pe=s(t,"H3",{class:!0});var Tl=c(Pe);ot=s(Tl,"A",{id:!0,class:!0,href:!0});var ev=c(ot);sn=s(ev,"SPAN",{});var tv=c(sn);b(Pa.$$.fragment,tv),tv.forEach(a),ev.forEach(a),Sd=i(Tl),cn=s(Tl,"SPAN",{});var av=c(cn);Ld=o(av,"Synchronicity control"),av.forEach(a),Tl.forEach(a),rl=i(t),nt=s(t,"P",{});var zl=c(nt);Cd=o(zl,"Use "),ao=s(zl,"A",{href:!0});var rv=c(ao);Nd=o(rv,"wait_for_everyone()"),rv.forEach(a),qd=o(zl," to make sure all processes join that point before continuing. (Useful before a model save for instance)"),zl.forEach(a),ol=i(t),De=s(t,"H3",{class:!0});var Ol=c(De);st=s(Ol,"A",{id:!0,class:!0,href:!0});var ov=c(st);ln=s(ov,"SPAN",{});var nv=c(ln);b(Da.$$.fragment,nv),nv.forEach(a),ov.forEach(a),Ud=i(Ol),dn=s(Ol,"SPAN",{});var sv=c(dn);Rd=o(sv,"Saving and loading"),sv.forEach(a),Ol.forEach(a),nl=i(t),ct=s(t,"P",{});var Il=c(ct);Md=o(Il,"Use "),ro=s(Il,"A",{href:!0});var cv=c(ro);Vd=o(cv,"unwrap_model()"),cv.forEach(a),Gd=o(Il," before saving to remove all special model wrappers added during the distributed process."),Il.forEach(a),sl=i(t),b(Ta.$$.fragment,t),cl=i(t),ae=s(t,"P",{});var $o=c(ae);Wd=o($o,"Use "),oo=s($o,"A",{href:!0});var lv=c(oo);Fd=o(lv,"save()"),lv.forEach(a),Hd=o($o," instead of "),pn=s($o,"CODE",{});var iv=c(pn);Yd=o(iv,"torch.save"),iv.forEach(a),Bd=o($o,":"),$o.forEach(a),ll=i(t),b(za.$$.fragment,t),il=i(t),Te=s(t,"H3",{class:!0});var Sl=c(Te);lt=s(Sl,"A",{id:!0,class:!0,href:!0});var dv=c(lt);hn=s(dv,"SPAN",{});var pv=c(hn);b(Oa.$$.fragment,pv),pv.forEach(a),dv.forEach(a),Jd=i(Sl),mn=s(Sl,"SPAN",{});var hv=c(mn);Kd=o(hv,"Operations"),hv.forEach(a),Sl.forEach(a),dl=i(t),W=s(t,"P",{});var Me=c(W);Qd=o(Me,"Use "),it=s(Me,"A",{href:!0});var Ll=c(it);Xd=o(Ll,"clip"),un=s(Ll,"EM",{});var mv=c(un);Zd=o(mv,"grad_norm"),mv.forEach(a),ep=o(Ll,"()"),Ll.forEach(a),tp=o(Me," instead of "),fn=s(Me,"CODE",{});var uv=c(fn);ap=o(uv,"torch.nn.utils.clip_grad_norm_"),uv.forEach(a),rp=o(Me," and "),dt=s(Me,"A",{href:!0});var Cl=c(dt);op=o(Cl,"clip"),gn=s(Cl,"EM",{});var fv=c(gn);np=o(fv,"grad_value"),fv.forEach(a),sp=o(Cl,"()"),Cl.forEach(a),cp=o(Me," instead of "),_n=s(Me,"CODE",{});var gv=c(_n);lp=o(gv,"torch.nn.utils.clip_grad_value"),gv.forEach(a),Me.forEach(a),pl=i(t),ze=s(t,"H3",{class:!0});var Nl=c(ze);pt=s(Nl,"A",{id:!0,class:!0,href:!0});var _v=c(pt);vn=s(_v,"SPAN",{});var vv=c(vn);b(Ia.$$.fragment,vv),vv.forEach(a),_v.forEach(a),ip=i(Nl),$n=s(Nl,"SPAN",{});var $v=c($n);dp=o($v,"Gradient Accumulation"),$v.forEach(a),Nl.forEach(a),hl=i(t),ht=s(t,"P",{});var ql=c(ht);pp=o(ql,"To perform gradient accumulation use "),no=s(ql,"A",{href:!0});var bv=c(no);hp=o(bv,"accumulate()"),bv.forEach(a),mp=o(ql,` and specify a gradient_accumulation_steps.
This will also automatically ensure the gradients are synced or unsynced when on
multi-device training, check if the step should actually be performed, and auto-scale the loss:`),ql.forEach(a),ml=i(t),b(Sa.$$.fragment,t),ul=i(t),Oe=s(t,"H2",{class:!0});var Ul=c(Oe);mt=s(Ul,"A",{id:!0,class:!0,href:!0});var yv=c(mt);bn=s(yv,"SPAN",{});var wv=c(bn);b(La.$$.fragment,wv),wv.forEach(a),yv.forEach(a),up=i(Ul),yn=s(Ul,"SPAN",{});var Ev=c(yn);fp=o(Ev,"Overall API documentation:"),Ev.forEach(a),Ul.forEach(a),fl=i(t),f=s(t,"DIV",{class:!0});var v=c(f);b(Ca.$$.fragment,v),gp=i(v),wn=s(v,"P",{});var Av=c(wn);_p=o(Av,"Creates an instance of an accelerator for distributed training (on multi-GPU, TPU) or mixed precision training."),Av.forEach(a),vp=i(v),En=s(v,"P",{});var kv=c(En);An=s(kv,"STRONG",{});var xv=c(An);$p=o(xv,"Available attributes:"),xv.forEach(a),kv.forEach(a),bp=i(v),T=s(v,"UL",{});var O=c(T);ut=s(O,"LI",{});var $c=c(ut);kn=s($c,"STRONG",{});var jv=c(kn);yp=o(jv,"device"),jv.forEach(a),wp=o($c," ("),xn=s($c,"CODE",{});var Pv=c(xn);Ep=o(Pv,"torch.device"),Pv.forEach(a),Ap=o($c,") \u2014 The device to use."),$c.forEach(a),kp=i(O),ft=s(O,"LI",{});var bc=c(ft);jn=s(bc,"STRONG",{});var Dv=c(jn);xp=o(Dv,"distributed_type"),Dv.forEach(a),jp=o(bc," ("),so=s(bc,"A",{href:!0});var Tv=c(so);Pp=o(Tv,"DistributedType"),Tv.forEach(a),Dp=o(bc,") \u2014 The distributed training configuration."),bc.forEach(a),Tp=i(O),gt=s(O,"LI",{});var yc=c(gt);Pn=s(yc,"STRONG",{});var zv=c(Pn);zp=o(zv,"local_process_index"),zv.forEach(a),Op=o(yc," ("),Dn=s(yc,"CODE",{});var Ov=c(Dn);Ip=o(Ov,"int"),Ov.forEach(a),Sp=o(yc,") \u2014 The process index on the current machine."),yc.forEach(a),Lp=i(O),_t=s(O,"LI",{});var wc=c(_t);Tn=s(wc,"STRONG",{});var Iv=c(Tn);Cp=o(Iv,"mixed_precision"),Iv.forEach(a),Np=o(wc," ("),zn=s(wc,"CODE",{});var Sv=c(zn);qp=o(Sv,"str"),Sv.forEach(a),Up=o(wc,") \u2014 The configured mixed precision mode."),wc.forEach(a),Rp=i(O),vt=s(O,"LI",{});var Ec=c(vt);On=s(Ec,"STRONG",{});var Lv=c(On);Mp=o(Lv,"num_processes"),Lv.forEach(a),Vp=o(Ec," ("),In=s(Ec,"CODE",{});var Cv=c(In);Gp=o(Cv,"int"),Cv.forEach(a),Wp=o(Ec,") \u2014 The total number of processes used for training."),Ec.forEach(a),Fp=i(O),$t=s(O,"LI",{});var Ac=c($t);Sn=s(Ac,"STRONG",{});var Nv=c(Sn);Hp=o(Nv,"optimizer_step_was_skipped"),Nv.forEach(a),Yp=o(Ac," ("),Ln=s(Ac,"CODE",{});var qv=c(Ln);Bp=o(qv,"bool"),qv.forEach(a),Jp=o(Ac,`) \u2014 Whether or not the optimizer update was skipped (because of
gradient overflow in mixed precision), in which
case the learning rate should not be changed.`),Ac.forEach(a),Kp=i(O),bt=s(O,"LI",{});var kc=c(bt);Cn=s(kc,"STRONG",{});var Uv=c(Cn);Qp=o(Uv,"process_index"),Uv.forEach(a),Xp=o(kc," ("),Nn=s(kc,"CODE",{});var Rv=c(Nn);Zp=o(Rv,"int"),Rv.forEach(a),eh=o(kc,") \u2014 The overall index of the current process among all processes."),kc.forEach(a),th=i(O),yt=s(O,"LI",{});var xc=c(yt);qn=s(xc,"STRONG",{});var Mv=c(qn);ah=o(Mv,"state"),Mv.forEach(a),rh=o(xc," ("),co=s(xc,"A",{href:!0});var Vv=c(co);oh=o(Vv,"AcceleratorState"),Vv.forEach(a),nh=o(xc,") \u2014 The distributed setup state."),xc.forEach(a),sh=i(O),wt=s(O,"LI",{});var jc=c(wt);Un=s(jc,"STRONG",{});var Gv=c(Un);ch=o(Gv,"sync_gradients"),Gv.forEach(a),lh=o(jc," ("),Rn=s(jc,"CODE",{});var Wv=c(Rn);ih=o(Wv,"bool"),Wv.forEach(a),dh=o(jc,") \u2014 Whether the gradients are currently being synced across all processes."),jc.forEach(a),ph=i(O),Et=s(O,"LI",{});var Pc=c(Et);Mn=s(Pc,"STRONG",{});var Fv=c(Mn);hh=o(Fv,"use_distributed"),Fv.forEach(a),mh=o(Pc," ("),Vn=s(Pc,"CODE",{});var Hv=c(Vn);uh=o(Hv,"bool"),Hv.forEach(a),fh=o(Pc,") \u2014 Whether the current configuration is for distributed training."),Pc.forEach(a),O.forEach(a),gh=i(v),re=s(v,"DIV",{class:!0});var bo=c(re);b(Na.$$.fragment,bo),_h=i(bo),Gn=s(bo,"P",{});var Yv=c(Gn);vh=o(Yv,"A context manager that will lightly wrap around and perform gradient accumulation automatically"),Yv.forEach(a),$h=i(bo),b(At.$$.fragment,bo),bo.forEach(a),bh=i(v),kt=s(v,"DIV",{class:!0});var Rl=c(kt);b(qa.$$.fragment,Rl),yh=i(Rl),Wn=s(Rl,"P",{});var Bv=c(Wn);wh=o(Bv,`Will apply automatic mixed-precision inside the block inside this context manager, if it is enabled. Nothing
different will happen otherwise.`),Bv.forEach(a),Rl.forEach(a),Eh=i(v),oe=s(v,"DIV",{class:!0});var yo=c(oe);b(Ua.$$.fragment,yo),Ah=i(yo),Ie=s(yo,"P",{});var wo=c(Ie);kh=o(wo,"Scales the gradients in accordance to "),Fn=s(wo,"CODE",{});var Jv=c(Fn);xh=o(Jv,"Accelerator.gradient_accumulation_steps"),Jv.forEach(a),jh=o(wo,` and calls the correct
`),Hn=s(wo,"CODE",{});var Kv=c(Hn);Ph=o(Kv,"backward()"),Kv.forEach(a),Dh=o(wo," based on the configuration."),wo.forEach(a),Th=i(yo),Ra=s(yo,"P",{});var Ml=c(Ra);zh=o(Ml,"Should be used in lieu of "),Yn=s(Ml,"CODE",{});var Qv=c(Yn);Oh=o(Qv,"loss.backward()"),Qv.forEach(a),Ih=o(Ml,"."),Ml.forEach(a),yo.forEach(a),Sh=i(v),xt=s(v,"DIV",{class:!0});var Vl=c(xt);b(Ma.$$.fragment,Vl),Lh=i(Vl),Va=s(Vl,"P",{});var Gl=c(Va);Ch=o(Gl,"Alias for "),Bn=s(Gl,"CODE",{});var Xv=c(Bn);Nh=o(Xv,"Accelerate.free_memory"),Xv.forEach(a),qh=o(Gl,`, releases all references to the internal objects stored and call the
garbage collector. You should call this method between two trainings with different models/optimizers.`),Gl.forEach(a),Vl.forEach(a),Uh=i(v),ne=s(v,"DIV",{class:!0});var Eo=c(ne);b(Ga.$$.fragment,Eo),Rh=i(Eo),Wa=s(Eo,"P",{});var Wl=c(Wa);Mh=o(Wl,"Should be used in place of "),Jn=s(Wl,"CODE",{});var Zv=c(Jn);Vh=o(Zv,"torch.nn.utils.clip_grad_norm_"),Zv.forEach(a),Gh=o(Wl,"."),Wl.forEach(a),Wh=i(Eo),b(jt.$$.fragment,Eo),Eo.forEach(a),Fh=i(v),se=s(v,"DIV",{class:!0});var Ao=c(se);b(Fa.$$.fragment,Ao),Hh=i(Ao),Ha=s(Ao,"P",{});var Fl=c(Ha);Yh=o(Fl,"Should be used in place of "),Kn=s(Fl,"CODE",{});var e$=c(Kn);Bh=o(e$,"torch.nn.utils.clip_grad_value_"),e$.forEach(a),Jh=o(Fl,"."),Fl.forEach(a),Kh=i(Ao),b(Pt.$$.fragment,Ao),Ao.forEach(a),Qh=i(v),Dt=s(v,"DIV",{class:!0});var Hl=c(Dt);b(Ya.$$.fragment,Hl),Xh=i(Hl),Qn=s(Hl,"P",{});var t$=c(Qn);Zh=o(t$,`Runs any special end training behaviors, such as stopping trackers on the main process only. Should always be
called at the end of your script if using experiment tracking.`),t$.forEach(a),Hl.forEach(a),em=i(v),Tt=s(v,"DIV",{class:!0});var Yl=c(Tt);b(Ba.$$.fragment,Yl),tm=i(Yl),Xn=s(Yl,"P",{});var a$=c(Xn);am=o(a$,`Will release all references to the internal objects stored and call the garbage collector. You should call this
method between two trainings with different models/optimizers.`),a$.forEach(a),Yl.forEach(a),rm=i(v),ce=s(v,"DIV",{class:!0});var ko=c(ce);b(Ja.$$.fragment,ko),om=i(ko),Ka=s(ko,"P",{});var Bl=c(Ka);nm=o(Bl,"Gather the values in "),Zn=s(Bl,"EM",{});var r$=c(Zn);sm=o(r$,"tensor"),r$.forEach(a),cm=o(Bl,` across all processes and concatenate them on the first dimension. Useful to
regroup the predictions from all processes when doing evaluation.`),Bl.forEach(a),lm=i(ko),es=s(ko,"P",{});var o$=c(es);im=o(o$,`Note:
This gather happens in all processes.`),o$.forEach(a),ko.forEach(a),dm=i(v),zt=s(v,"DIV",{class:!0});var Jl=c(zt);b(Qa.$$.fragment,Jl),pm=i(Jl),Xa=s(Jl,"P",{});var Kl=c(Xa);hm=o(Kl,"Gathers "),ts=s(Kl,"CODE",{});var n$=c(ts);mm=o(n$,"tensor"),n$.forEach(a),um=o(Kl,` and potentially drops duplicates in the last batch if on a distributed system. Should be used
for gathering the inputs and targets for metric calculation.`),Kl.forEach(a),Jl.forEach(a),fm=i(v),Ot=s(v,"DIV",{class:!0});var Ql=c(Ot);b(Za.$$.fragment,Ql),gm=i(Ql),er=s(Ql,"P",{});var Xl=c(er);_m=o(Xl,"Returns the state dictionary of a model sent through "),lo=s(Xl,"A",{href:!0});var s$=c(lo);vm=o(s$,"Accelerator.prepare()"),s$.forEach(a),$m=o(Xl," in full precision"),Xl.forEach(a),Ql.forEach(a),bm=i(v),It=s(v,"DIV",{class:!0});var Zl=c(It);b(tr.$$.fragment,Zl),ym=i(Zl),Z=s(Zl,"P",{});var la=c(Z);wm=o(la,"Returns a "),as=s(la,"CODE",{});var c$=c(as);Em=o(c$,"tracker"),c$.forEach(a),Am=o(la," from "),rs=s(la,"CODE",{});var l$=c(rs);km=o(l$,"self.trackers"),l$.forEach(a),xm=o(la," based on "),os=s(la,"CODE",{});var i$=c(os);jm=o(i$,"name"),i$.forEach(a),Pm=o(la," on the main process only."),la.forEach(a),Zl.forEach(a),Dm=i(v),St=s(v,"DIV",{class:!0});var ei=c(St);b(ar.$$.fragment,ei),Tm=i(ei),rr=s(ei,"P",{});var ti=c(rr);zm=o(ti,"Initializes a run for all trackers stored in "),ns=s(ti,"CODE",{});var d$=c(ns);Om=o(d$,"self.log_with"),d$.forEach(a),Im=o(ti,", potentially with starting configurations"),ti.forEach(a),ei.forEach(a),Sm=i(v),M=s(v,"DIV",{class:!0});var me=c(M);b(or.$$.fragment,me),Lm=i(me),nr=s(me,"P",{});var ai=c(nr);Cm=o(ai,`A context manager that facilitates distributed training or evaluation on uneven inputs, which acts as a wrapper
around `),ss=s(ai,"CODE",{});var p$=c(ss);Nm=o(p$,"torch.distributed.algorithms.join"),p$.forEach(a),qm=o(ai,`. This is useful when the total batch size does not evenly divide the
length of the dataset.`),ai.forEach(a),Um=i(me),b(Lt.$$.fragment,me),Rm=i(me),b(Ct.$$.fragment,me),Mm=i(me),b(Nt.$$.fragment,me),me.forEach(a),Vm=i(v),le=s(v,"DIV",{class:!0});var xo=c(le);b(sr.$$.fragment,xo),Gm=i(xo),cs=s(xo,"P",{});var h$=c(cs);Wm=o(h$,"Loads the current states of the model, optimizer, scaler, RNG generators, and registered objects."),h$.forEach(a),Fm=i(xo),b(qt.$$.fragment,xo),xo.forEach(a),Hm=i(v),ie=s(v,"DIV",{class:!0});var jo=c(ie);b(cr.$$.fragment,jo),Ym=i(jo),ls=s(jo,"P",{});var m$=c(ls);Bm=o(m$,"Lets the local main process go inside a with block."),m$.forEach(a),Jm=i(jo),is=s(jo,"P",{});var u$=c(is);Km=o(u$,"The other processes will enter the with block after the main process exits."),u$.forEach(a),jo.forEach(a),Qm=i(v),Ut=s(v,"DIV",{class:!0});var ri=c(Ut);b(lr.$$.fragment,ri),Xm=i(ri),Se=s(ri,"P",{});var Po=c(Se);Zm=o(Po,"Logs "),ds=s(Po,"CODE",{});var f$=c(ds);eu=o(f$,"values"),f$.forEach(a),tu=o(Po," to all stored trackers in "),ps=s(Po,"CODE",{});var g$=c(ps);au=o(g$,"self.trackers"),g$.forEach(a),ru=o(Po," on the main process only."),Po.forEach(a),ri.forEach(a),ou=i(v),de=s(v,"DIV",{class:!0});var Do=c(de);b(ir.$$.fragment,Do),nu=i(Do),hs=s(Do,"P",{});var _$=c(hs);su=o(_$,"Lets the main process go first inside a with block."),_$.forEach(a),cu=i(Do),ms=s(Do,"P",{});var v$=c(ms);lu=o(v$,"The other processes will enter the with block after the main process exits."),v$.forEach(a),Do.forEach(a),iu=i(v),Y=s(v,"DIV",{class:!0});var ia=c(Y);b(dr.$$.fragment,ia),du=i(ia),pr=s(ia,"P",{});var oi=c(pr);pu=o(oi,`A context manager to disable gradient synchronizations across DDP processes by calling
`),us=s(oi,"CODE",{});var $$=c(us);hu=o($$,"torch.nn.parallel.DistributedDataParallel.no_sync"),$$.forEach(a),mu=o(oi,"."),oi.forEach(a),uu=i(ia),hr=s(ia,"P",{});var ni=c(hr);fu=o(ni,"If "),fs=s(ni,"CODE",{});var b$=c(fs);gu=o(b$,"model"),b$.forEach(a),_u=o(ni," is not in DDP, this context manager does nothing"),ni.forEach(a),vu=i(ia),b(Rt.$$.fragment,ia),ia.forEach(a),$u=i(v),Mt=s(v,"DIV",{class:!0});var si=c(Mt);b(mr.$$.fragment,si),bu=i(si),gs=s(si,"P",{});var y$=c(gs);yu=o(y$,"A decorator that will run the decorated function on the last process only."),y$.forEach(a),si.forEach(a),wu=i(v),Vt=s(v,"DIV",{class:!0});var ci=c(Vt);b(ur.$$.fragment,ci),Eu=i(ci),_s=s(ci,"P",{});var w$=c(_s);Au=o(w$,"A decorator that will run the decorated function on the local main process only."),w$.forEach(a),ci.forEach(a),ku=i(v),Gt=s(v,"DIV",{class:!0});var li=c(Gt);b(fr.$$.fragment,li),xu=i(li),vs=s(li,"P",{});var E$=c(vs);ju=o(E$,"A decorator that will run the decorated function on a given local process index only."),E$.forEach(a),li.forEach(a),Pu=i(v),Wt=s(v,"DIV",{class:!0});var ii=c(Wt);b(gr.$$.fragment,ii),Du=i(ii),$s=s(ii,"P",{});var A$=c($s);Tu=o(A$,"A decorator that will run the decorated function on the main process only."),A$.forEach(a),ii.forEach(a),zu=i(v),Ft=s(v,"DIV",{class:!0});var di=c(Ft);b(_r.$$.fragment,di),Ou=i(di),bs=s(di,"P",{});var k$=c(bs);Iu=o(k$,"A decorator that will run the decorated function on a given process index only."),k$.forEach(a),di.forEach(a),Su=i(v),Ht=s(v,"DIV",{class:!0});var pi=c(Ht);b(vr.$$.fragment,pi),Lu=i(pi),ys=s(pi,"P",{});var x$=c(ys);Cu=o(x$,`Recursively pad the tensors in a nested list/tuple/dictionary of tensors from all devices to the same size so
they can safely be gathered.`),x$.forEach(a),pi.forEach(a),Nu=i(v),pe=s(v,"DIV",{class:!0});var To=c(pe);b($r.$$.fragment,To),qu=i(To),br=s(To,"P",{});var hi=c(br);Uu=o(hi,"Prepare all objects passed in "),ws=s(hi,"CODE",{});var j$=c(ws);Ru=o(j$,"args"),j$.forEach(a),Mu=o(hi,` for distributed training and mixed precision, then return them in the same
order.`),hi.forEach(a),Vu=i(To),b(Yt.$$.fragment,To),To.forEach(a),Gu=i(v),Bt=s(v,"DIV",{class:!0});var mi=c(Bt);b(yr.$$.fragment,mi),Wu=i(mi),wr=s(mi,"P",{});var ui=c(wr);Fu=o(ui,`Prepares a PyTorch DataLoader for training in any distributed setup. It is recommended to use
`),io=s(ui,"A",{href:!0});var P$=c(io);Hu=o(P$,"Accelerator.prepare()"),P$.forEach(a),Yu=o(ui," instead."),ui.forEach(a),mi.forEach(a),Bu=i(v),Jt=s(v,"DIV",{class:!0});var fi=c(Jt);b(Er.$$.fragment,fi),Ju=i(fi),Ar=s(fi,"P",{});var gi=c(Ar);Ku=o(gi,`Prepares a PyTorch model for training in any distributed setup. It is recommended to use
`),po=s(gi,"A",{href:!0});var D$=c(po);Qu=o(D$,"Accelerator.prepare()"),D$.forEach(a),Xu=o(gi," instead."),gi.forEach(a),fi.forEach(a),Zu=i(v),Kt=s(v,"DIV",{class:!0});var _i=c(Kt);b(kr.$$.fragment,_i),ef=i(_i),xr=s(_i,"P",{});var vi=c(xr);tf=o(vi,`Prepares a PyTorch Optimizer for training in any distributed setup. It is recommended to use
`),ho=s(vi,"A",{href:!0});var T$=c(ho);af=o(T$,"Accelerator.prepare()"),T$.forEach(a),rf=o(vi," instead."),vi.forEach(a),_i.forEach(a),of=i(v),Qt=s(v,"DIV",{class:!0});var $i=c(Qt);b(jr.$$.fragment,$i),nf=i($i),Pr=s($i,"P",{});var bi=c(Pr);sf=o(bi,`Prepares a PyTorch Scheduler for training in any distributed setup. It is recommended to use
`),mo=s(bi,"A",{href:!0});var z$=c(mo);cf=o(z$,"Accelerator.prepare()"),z$.forEach(a),lf=o(bi," instead."),bi.forEach(a),$i.forEach(a),df=i(v),Xt=s(v,"DIV",{class:!0});var yi=c(Xt);b(Dr.$$.fragment,yi),pf=i(yi),Tr=s(yi,"P",{});var wi=c(Tr);hf=o(wi,"Use in replacement of "),Es=s(wi,"CODE",{});var O$=c(Es);mf=o(O$,"print()"),O$.forEach(a),uf=o(wi," to only print once per server."),wi.forEach(a),yi.forEach(a),ff=i(v),he=s(v,"DIV",{class:!0});var zo=c(he);b(zr.$$.fragment,zo),gf=i(zo),Le=s(zo,"P",{});var Oo=c(Le);_f=o(Oo,"Reduce the values in "),As=s(Oo,"EM",{});var I$=c(As);vf=o(I$,"tensor"),I$.forEach(a),$f=o(Oo," across all processes based on "),ks=s(Oo,"EM",{});var S$=c(ks);bf=o(S$,"reduction"),S$.forEach(a),yf=o(Oo,"."),Oo.forEach(a),wf=i(zo),xs=s(zo,"P",{});var L$=c(xs);Ef=o(L$,`Note:
All processes get the reduced value.`),L$.forEach(a),zo.forEach(a),Af=i(v),B=s(v,"DIV",{class:!0});var da=c(B);b(Or.$$.fragment,da),kf=i(da),ee=s(da,"P",{});var pa=c(ee);xf=o(pa,"Makes note of "),js=s(pa,"CODE",{});var C$=c(js);jf=o(C$,"objects"),C$.forEach(a),Pf=o(pa," and will save or load them in during "),Ps=s(pa,"CODE",{});var N$=c(Ps);Df=o(N$,"save_state"),N$.forEach(a),Tf=o(pa," or "),Ds=s(pa,"CODE",{});var q$=c(Ds);zf=o(q$,"load_state"),q$.forEach(a),Of=o(pa,"."),pa.forEach(a),If=i(da),Ts=s(da,"P",{});var U$=c(Ts);Sf=o(U$,`These should be utilized when the state is being loaded or saved in the same script. It is not designed to be
used in different scripts`),U$.forEach(a),Lf=i(da),b(Zt.$$.fragment,da),da.forEach(a),Cf=i(v),C=s(v,"DIV",{class:!0});var J=c(C);b(Ir.$$.fragment,J),Nf=i(J),Ce=s(J,"P",{});var Io=c(Ce);qf=o(Io,"Registers a pre hook to be run before "),zs=s(Io,"CODE",{});var R$=c(zs);Uf=o(R$,"load_checkpoint"),R$.forEach(a),Rf=o(Io," is called in "),uo=s(Io,"A",{href:!0});var M$=c(uo);Mf=o(M$,"Accelerator.load_state()"),M$.forEach(a),Vf=o(Io,"."),Io.forEach(a),Gf=i(J),Os=s(J,"P",{});var V$=c(Os);Wf=o(V$,"The hook should have the following signature:"),V$.forEach(a),Ff=i(J),Is=s(J,"P",{});var G$=c(Is);Ss=s(G$,"CODE",{});var W$=c(Ss);Hf=o(W$,"hook(models: List[torch.nn.Module], input_dir: str) -> None"),W$.forEach(a),G$.forEach(a),Yf=i(J),U=s(J,"P",{});var K=c(U);Bf=o(K,"The "),Ls=s(K,"CODE",{});var F$=c(Ls);Jf=o(F$,"models"),F$.forEach(a),Kf=o(K," argument are the models as saved in the accelerator state under "),Cs=s(K,"CODE",{});var H$=c(Cs);Qf=o(H$,"accelerator._models"),H$.forEach(a),Xf=o(K,`, and the
`),Ns=s(K,"CODE",{});var Y$=c(Ns);Zf=o(Y$,"input_dir"),Y$.forEach(a),eg=o(K," argument is the "),qs=s(K,"CODE",{});var B$=c(qs);tg=o(B$,"input_dir"),B$.forEach(a),ag=o(K," argument passed to "),fo=s(K,"A",{href:!0});var J$=c(fo);rg=o(J$,"Accelerator.load_state()"),J$.forEach(a),og=o(K,"."),K.forEach(a),ng=i(J),b(ea.$$.fragment,J),J.forEach(a),sg=i(v),N=s(v,"DIV",{class:!0});var Q=c(N);b(Sr.$$.fragment,Q),cg=i(Q),Ne=s(Q,"P",{});var So=c(Ne);lg=o(So,"Registers a pre hook to be run before "),Us=s(So,"CODE",{});var K$=c(Us);ig=o(K$,"save_checkpoint"),K$.forEach(a),dg=o(So," is called in "),go=s(So,"A",{href:!0});var Q$=c(go);pg=o(Q$,"Accelerator.save_state()"),Q$.forEach(a),hg=o(So,"."),So.forEach(a),mg=i(Q),Rs=s(Q,"P",{});var X$=c(Rs);ug=o(X$,"The hook should have the following signature:"),X$.forEach(a),fg=i(Q),Ms=s(Q,"P",{});var Z$=c(Ms);Vs=s(Z$,"CODE",{});var eb=c(Vs);gg=o(eb,"hook(models: List[torch.nn.Module], weights: List[Dict[str, torch.Tensor]], input_dir: str) -> None"),eb.forEach(a),Z$.forEach(a),_g=i(Q),I=s(Q,"P",{});var q=c(I);vg=o(q,"The "),Gs=s(q,"CODE",{});var tb=c(Gs);$g=o(tb,"models"),tb.forEach(a),bg=o(q," argument are the models as saved in the accelerator state under "),Ws=s(q,"CODE",{});var ab=c(Ws);yg=o(ab,"accelerator._models"),ab.forEach(a),wg=o(q,", "),Fs=s(q,"CODE",{});var rb=c(Fs);Eg=o(rb,"weigths"),rb.forEach(a),Ag=o(q,`
argument are the state dicts of the `),Hs=s(q,"CODE",{});var ob=c(Hs);kg=o(ob,"models"),ob.forEach(a),xg=o(q,", and the "),Ys=s(q,"CODE",{});var nb=c(Ys);jg=o(nb,"input_dir"),nb.forEach(a),Pg=o(q," argument is the "),Bs=s(q,"CODE",{});var sb=c(Bs);Dg=o(sb,"input_dir"),sb.forEach(a),Tg=o(q,` argument passed
to `),_o=s(q,"A",{href:!0});var cb=c(_o);zg=o(cb,"Accelerator.load_state()"),cb.forEach(a),Og=o(q,"."),q.forEach(a),Ig=i(Q),b(ta.$$.fragment,Q),Q.forEach(a),Sg=i(v),aa=s(v,"DIV",{class:!0});var Ei=c(aa);b(Lr.$$.fragment,Ei),Lg=i(Ei),Cr=s(Ei,"P",{});var Ai=c(Cr);Cg=o(Ai,"Save the object passed to disk once per machine. Use in place of "),Js=s(Ai,"CODE",{});var lb=c(Js);Ng=o(lb,"torch.save"),lb.forEach(a),qg=o(Ai,"."),Ai.forEach(a),Ei.forEach(a),Ug=i(v),V=s(v,"DIV",{class:!0});var ue=c(V);b(Nr.$$.fragment,ue),Rg=i(ue),Ks=s(ue,"P",{});var ib=c(Ks);Mg=o(ib,"Saves the current states of the model, optimizer, scaler, RNG generators, and registered objects to a folder."),ib.forEach(a),Vg=i(ue),L=s(ue,"P",{});var G=c(L);Gg=o(G,"If a "),Qs=s(G,"CODE",{});var db=c(Qs);Wg=o(db,"ProjectConfiguration"),db.forEach(a),Fg=o(G," was passed to the "),Xs=s(G,"CODE",{});var pb=c(Xs);Hg=o(pb,"Accelerator"),pb.forEach(a),Yg=o(G," object with "),Zs=s(G,"CODE",{});var hb=c(Zs);Bg=o(hb,"automatic_checkpoint_naming"),hb.forEach(a),Jg=o(G,` enabled
then checkpoints will be saved to `),ec=s(G,"CODE",{});var mb=c(ec);Kg=o(mb,"self.project_dir/checkpoints"),mb.forEach(a),Qg=o(G,`. If the number of current saves is greater
than `),tc=s(G,"CODE",{});var ub=c(tc);Xg=o(ub,"total_limit"),ub.forEach(a),Zg=o(G,` then the oldest save is deleted. Each checkpoint is saved in seperate folders named
`),ac=s(G,"CODE",{});var fb=c(ac);e_=o(fb,"checkpoint_<iteration>"),fb.forEach(a),t_=o(G,"."),G.forEach(a),a_=i(ue),qr=s(ue,"P",{});var ki=c(qr);r_=o(ki,"Otherwise they are just saved to "),rc=s(ki,"CODE",{});var gb=c(rc);o_=o(gb,"output_dir"),gb.forEach(a),n_=o(ki,"."),ki.forEach(a),s_=i(ue),b(ra.$$.fragment,ue),ue.forEach(a),c_=i(v),oa=s(v,"DIV",{class:!0});var xi=c(oa);b(Ur.$$.fragment,xi),l_=i(xi),oc=s(xi,"P",{});var _b=c(oc);i_=o(_b,"Unscale the gradients in mixed precision training with AMP. This is a noop in all other settings."),_b.forEach(a),xi.forEach(a),d_=i(v),na=s(v,"DIV",{class:!0});var ji=c(na);b(Rr.$$.fragment,ji),p_=i(ji),qe=s(ji,"P",{});var Lo=c(qe);h_=o(Lo,"Unwraps the "),nc=s(Lo,"CODE",{});var vb=c(nc);m_=o(vb,"model"),vb.forEach(a),u_=o(Lo," from the additional layer possible added by "),vo=s(Lo,"A",{href:!0});var $b=c(vo);f_=o($b,"prepare()"),$b.forEach(a),g_=o(Lo,`. Useful before saving
the model.`),Lo.forEach(a),ji.forEach(a),__=i(v),sa=s(v,"DIV",{class:!0});var Pi=c(sa);b(Mr.$$.fragment,Pi),v_=i(Pi),sc=s(Pi,"P",{});var bb=c(sc);$_=o(bb,`Will stop the execution of the current process until every other process has reached that point (so this does
nothing when the script is only run in one process). Useful to do before saving a model.`),bb.forEach(a),Pi.forEach(a),v.forEach(a),this.h()},h(){p(d,"name","hf:doc:metadata"),p(d,"content",JSON.stringify(Vb)),p(g,"id","accelerator"),p(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(g,"href","#accelerator"),p(u,"class","relative group"),p(S,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator"),p(Ge,"id","quick-adaptation-of-your-code"),p(Ge,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(Ge,"href","#quick-adaptation-of-your-code"),p(ve,"class","relative group"),p(Br,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator"),p(Jr,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare"),p(Qr,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.gather"),p(be,"start","4"),p(Be,"id","advanced-recommendations"),p(Be,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(Be,"href","#advanced-recommendations"),p(ye,"class","relative group"),p(Je,"id","printing"),p(Je,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(Je,"href","#printing"),p(we,"class","relative group"),p(Xr,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.print"),p(Ke,"id","executing-processes"),p(Ke,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(Ke,"href","#executing-processes"),p(Ae,"class","relative group"),p(Qe,"id","once-on-a-single-server"),p(Qe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(Qe,"href","#once-on-a-single-server"),p(ke,"class","relative group"),p(Zr,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.on_local_main_process"),p(et,"id","only-ever-once-across-all-servers"),p(et,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(et,"href","#only-ever-once-across-all-servers"),p(xe,"class","relative group"),p(eo,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.on_main_process"),p(rt,"id","on-specific-processes"),p(rt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(rt,"href","#on-specific-processes"),p(je,"class","relative group"),p(ot,"id","synchronicity-control"),p(ot,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(ot,"href","#synchronicity-control"),p(Pe,"class","relative group"),p(ao,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.wait_for_everyone"),p(st,"id","saving-and-loading"),p(st,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(st,"href","#saving-and-loading"),p(De,"class","relative group"),p(ro,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.unwrap_model"),p(oo,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.save"),p(lt,"id","operations"),p(lt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(lt,"href","#operations"),p(Te,"class","relative group"),p(it,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.clip_grad_norm_"),p(dt,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.clip_grad_value_"),p(pt,"id","gradient-accumulation"),p(pt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(pt,"href","#gradient-accumulation"),p(ze,"class","relative group"),p(no,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.accumulate"),p(mt,"id","accelerate.Accelerator"),p(mt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(mt,"href","#accelerate.Accelerator"),p(Oe,"class","relative group"),p(so,"href","/docs/accelerate/main/en/package_reference/utilities#accelerate.DistributedType"),p(co,"href","/docs/accelerate/main/en/package_reference/state#accelerate.state.AcceleratorState"),p(re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(kt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(xt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(ne,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(Dt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(Tt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(zt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(lo,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare"),p(Ot,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(It,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(St,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(Ut,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(de,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(Y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(Mt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(Vt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(Gt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(Wt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(Ft,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(Ht,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(pe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(io,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare"),p(Bt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(po,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare"),p(Jt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(ho,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare"),p(Kt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(mo,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare"),p(Qt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(Xt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(he,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(uo,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.load_state"),p(fo,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.load_state"),p(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(go,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.save_state"),p(_o,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.load_state"),p(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(aa,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(oa,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(vo,"href","/docs/accelerate/main/en/package_reference/accelerator#accelerate.Accelerator.prepare"),p(na,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(sa,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(f,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,m){e(document.head,d),_(t,x,m),_(t,u,m),e(u,g),e(g,j),y(h,j,null),e(u,k),e(u,z),e(z,ge),_(t,Ve,m),_(t,H,m),e(H,_e),e(H,S),e(S,Fr),e(H,Hr),_(t,ha,m),_(t,ve,m),e(ve,Ge),e(Ge,Co),y(ma,Co,null),e(ve,Di),e(ve,No),e(No,Ti),_(t,zc,m),_(t,Yr,m),e(Yr,zi),_(t,Oc,m),_(t,te,m),e(te,$e),e($e,Oi),e($e,Br),e(Br,Ii),e($e,Si),e($e,qo),e(qo,Li),e($e,Ci),e(te,Ni),e(te,ua),e(ua,qi),e(ua,Jr),e(Jr,Ui),e(ua,Ri),e(te,Mi),e(te,X),e(X,Vi),e(X,Uo),e(Uo,Gi),e(X,Wi),e(X,Ro),e(Ro,Fi),e(X,Hi),e(X,Mo),e(Mo,Yi),e(X,Bi),_(t,Ic,m),y(We,t,m),_(t,Sc,m),_(t,be,m),e(be,Fe),e(Fe,Ji),e(Fe,Vo),e(Vo,Ki),e(Fe,Qi),e(Fe,Go),e(Go,Xi),e(be,Zi),e(be,Kr),e(Kr,ed),e(Kr,Qr),e(Qr,td),_(t,Lc,m),y(He,t,m),_(t,Cc,m),_(t,Ye,m),e(Ye,ad),e(Ye,Wo),e(Wo,rd),e(Ye,od),_(t,Nc,m),_(t,ye,m),e(ye,Be),e(Be,Fo),y(fa,Fo,null),e(ye,nd),e(ye,Ho),e(Ho,sd),_(t,qc,m),_(t,we,m),e(we,Je),e(Je,Yo),y(ga,Yo,null),e(we,cd),e(we,Bo),e(Bo,ld),_(t,Uc,m),_(t,Ee,m),e(Ee,Jo),e(Jo,id),e(Ee,dd),e(Ee,Xr),e(Xr,pd),e(Ee,hd),_(t,Rc,m),y(_a,t,m),_(t,Mc,m),_(t,Ae,m),e(Ae,Ke),e(Ke,Ko),y(va,Ko,null),e(Ae,md),e(Ae,Qo),e(Qo,ud),_(t,Vc,m),_(t,ke,m),e(ke,Qe),e(Qe,Xo),y($a,Xo,null),e(ke,fd),e(ke,Zo),e(Zo,gd),_(t,Gc,m),_(t,Xe,m),e(Xe,_d),e(Xe,en),e(en,vd),e(Xe,$d),_(t,Wc,m),y(ba,t,m),_(t,Fc,m),_(t,Ze,m),e(Ze,bd),e(Ze,Zr),e(Zr,yd),e(Ze,wd),_(t,Hc,m),y(ya,t,m),_(t,Yc,m),_(t,xe,m),e(xe,et),e(et,tn),y(wa,tn,null),e(xe,Ed),e(xe,an),e(an,Ad),_(t,Bc,m),_(t,tt,m),e(tt,kd),e(tt,rn),e(rn,xd),e(tt,jd),_(t,Jc,m),y(Ea,t,m),_(t,Kc,m),_(t,at,m),e(at,Pd),e(at,eo),e(eo,Dd),e(at,Td),_(t,Qc,m),y(Aa,t,m),_(t,Xc,m),_(t,je,m),e(je,rt),e(rt,on),y(ka,on,null),e(je,zd),e(je,nn),e(nn,Od),_(t,Zc,m),_(t,to,m),e(to,Id),_(t,el,m),y(xa,t,m),_(t,tl,m),y(ja,t,m),_(t,al,m),_(t,Pe,m),e(Pe,ot),e(ot,sn),y(Pa,sn,null),e(Pe,Sd),e(Pe,cn),e(cn,Ld),_(t,rl,m),_(t,nt,m),e(nt,Cd),e(nt,ao),e(ao,Nd),e(nt,qd),_(t,ol,m),_(t,De,m),e(De,st),e(st,ln),y(Da,ln,null),e(De,Ud),e(De,dn),e(dn,Rd),_(t,nl,m),_(t,ct,m),e(ct,Md),e(ct,ro),e(ro,Vd),e(ct,Gd),_(t,sl,m),y(Ta,t,m),_(t,cl,m),_(t,ae,m),e(ae,Wd),e(ae,oo),e(oo,Fd),e(ae,Hd),e(ae,pn),e(pn,Yd),e(ae,Bd),_(t,ll,m),y(za,t,m),_(t,il,m),_(t,Te,m),e(Te,lt),e(lt,hn),y(Oa,hn,null),e(Te,Jd),e(Te,mn),e(mn,Kd),_(t,dl,m),_(t,W,m),e(W,Qd),e(W,it),e(it,Xd),e(it,un),e(un,Zd),e(it,ep),e(W,tp),e(W,fn),e(fn,ap),e(W,rp),e(W,dt),e(dt,op),e(dt,gn),e(gn,np),e(dt,sp),e(W,cp),e(W,_n),e(_n,lp),_(t,pl,m),_(t,ze,m),e(ze,pt),e(pt,vn),y(Ia,vn,null),e(ze,ip),e(ze,$n),e($n,dp),_(t,hl,m),_(t,ht,m),e(ht,pp),e(ht,no),e(no,hp),e(ht,mp),_(t,ml,m),y(Sa,t,m),_(t,ul,m),_(t,Oe,m),e(Oe,mt),e(mt,bn),y(La,bn,null),e(Oe,up),e(Oe,yn),e(yn,fp),_(t,fl,m),_(t,f,m),y(Ca,f,null),e(f,gp),e(f,wn),e(wn,_p),e(f,vp),e(f,En),e(En,An),e(An,$p),e(f,bp),e(f,T),e(T,ut),e(ut,kn),e(kn,yp),e(ut,wp),e(ut,xn),e(xn,Ep),e(ut,Ap),e(T,kp),e(T,ft),e(ft,jn),e(jn,xp),e(ft,jp),e(ft,so),e(so,Pp),e(ft,Dp),e(T,Tp),e(T,gt),e(gt,Pn),e(Pn,zp),e(gt,Op),e(gt,Dn),e(Dn,Ip),e(gt,Sp),e(T,Lp),e(T,_t),e(_t,Tn),e(Tn,Cp),e(_t,Np),e(_t,zn),e(zn,qp),e(_t,Up),e(T,Rp),e(T,vt),e(vt,On),e(On,Mp),e(vt,Vp),e(vt,In),e(In,Gp),e(vt,Wp),e(T,Fp),e(T,$t),e($t,Sn),e(Sn,Hp),e($t,Yp),e($t,Ln),e(Ln,Bp),e($t,Jp),e(T,Kp),e(T,bt),e(bt,Cn),e(Cn,Qp),e(bt,Xp),e(bt,Nn),e(Nn,Zp),e(bt,eh),e(T,th),e(T,yt),e(yt,qn),e(qn,ah),e(yt,rh),e(yt,co),e(co,oh),e(yt,nh),e(T,sh),e(T,wt),e(wt,Un),e(Un,ch),e(wt,lh),e(wt,Rn),e(Rn,ih),e(wt,dh),e(T,ph),e(T,Et),e(Et,Mn),e(Mn,hh),e(Et,mh),e(Et,Vn),e(Vn,uh),e(Et,fh),e(f,gh),e(f,re),y(Na,re,null),e(re,_h),e(re,Gn),e(Gn,vh),e(re,$h),y(At,re,null),e(f,bh),e(f,kt),y(qa,kt,null),e(kt,yh),e(kt,Wn),e(Wn,wh),e(f,Eh),e(f,oe),y(Ua,oe,null),e(oe,Ah),e(oe,Ie),e(Ie,kh),e(Ie,Fn),e(Fn,xh),e(Ie,jh),e(Ie,Hn),e(Hn,Ph),e(Ie,Dh),e(oe,Th),e(oe,Ra),e(Ra,zh),e(Ra,Yn),e(Yn,Oh),e(Ra,Ih),e(f,Sh),e(f,xt),y(Ma,xt,null),e(xt,Lh),e(xt,Va),e(Va,Ch),e(Va,Bn),e(Bn,Nh),e(Va,qh),e(f,Uh),e(f,ne),y(Ga,ne,null),e(ne,Rh),e(ne,Wa),e(Wa,Mh),e(Wa,Jn),e(Jn,Vh),e(Wa,Gh),e(ne,Wh),y(jt,ne,null),e(f,Fh),e(f,se),y(Fa,se,null),e(se,Hh),e(se,Ha),e(Ha,Yh),e(Ha,Kn),e(Kn,Bh),e(Ha,Jh),e(se,Kh),y(Pt,se,null),e(f,Qh),e(f,Dt),y(Ya,Dt,null),e(Dt,Xh),e(Dt,Qn),e(Qn,Zh),e(f,em),e(f,Tt),y(Ba,Tt,null),e(Tt,tm),e(Tt,Xn),e(Xn,am),e(f,rm),e(f,ce),y(Ja,ce,null),e(ce,om),e(ce,Ka),e(Ka,nm),e(Ka,Zn),e(Zn,sm),e(Ka,cm),e(ce,lm),e(ce,es),e(es,im),e(f,dm),e(f,zt),y(Qa,zt,null),e(zt,pm),e(zt,Xa),e(Xa,hm),e(Xa,ts),e(ts,mm),e(Xa,um),e(f,fm),e(f,Ot),y(Za,Ot,null),e(Ot,gm),e(Ot,er),e(er,_m),e(er,lo),e(lo,vm),e(er,$m),e(f,bm),e(f,It),y(tr,It,null),e(It,ym),e(It,Z),e(Z,wm),e(Z,as),e(as,Em),e(Z,Am),e(Z,rs),e(rs,km),e(Z,xm),e(Z,os),e(os,jm),e(Z,Pm),e(f,Dm),e(f,St),y(ar,St,null),e(St,Tm),e(St,rr),e(rr,zm),e(rr,ns),e(ns,Om),e(rr,Im),e(f,Sm),e(f,M),y(or,M,null),e(M,Lm),e(M,nr),e(nr,Cm),e(nr,ss),e(ss,Nm),e(nr,qm),e(M,Um),y(Lt,M,null),e(M,Rm),y(Ct,M,null),e(M,Mm),y(Nt,M,null),e(f,Vm),e(f,le),y(sr,le,null),e(le,Gm),e(le,cs),e(cs,Wm),e(le,Fm),y(qt,le,null),e(f,Hm),e(f,ie),y(cr,ie,null),e(ie,Ym),e(ie,ls),e(ls,Bm),e(ie,Jm),e(ie,is),e(is,Km),e(f,Qm),e(f,Ut),y(lr,Ut,null),e(Ut,Xm),e(Ut,Se),e(Se,Zm),e(Se,ds),e(ds,eu),e(Se,tu),e(Se,ps),e(ps,au),e(Se,ru),e(f,ou),e(f,de),y(ir,de,null),e(de,nu),e(de,hs),e(hs,su),e(de,cu),e(de,ms),e(ms,lu),e(f,iu),e(f,Y),y(dr,Y,null),e(Y,du),e(Y,pr),e(pr,pu),e(pr,us),e(us,hu),e(pr,mu),e(Y,uu),e(Y,hr),e(hr,fu),e(hr,fs),e(fs,gu),e(hr,_u),e(Y,vu),y(Rt,Y,null),e(f,$u),e(f,Mt),y(mr,Mt,null),e(Mt,bu),e(Mt,gs),e(gs,yu),e(f,wu),e(f,Vt),y(ur,Vt,null),e(Vt,Eu),e(Vt,_s),e(_s,Au),e(f,ku),e(f,Gt),y(fr,Gt,null),e(Gt,xu),e(Gt,vs),e(vs,ju),e(f,Pu),e(f,Wt),y(gr,Wt,null),e(Wt,Du),e(Wt,$s),e($s,Tu),e(f,zu),e(f,Ft),y(_r,Ft,null),e(Ft,Ou),e(Ft,bs),e(bs,Iu),e(f,Su),e(f,Ht),y(vr,Ht,null),e(Ht,Lu),e(Ht,ys),e(ys,Cu),e(f,Nu),e(f,pe),y($r,pe,null),e(pe,qu),e(pe,br),e(br,Uu),e(br,ws),e(ws,Ru),e(br,Mu),e(pe,Vu),y(Yt,pe,null),e(f,Gu),e(f,Bt),y(yr,Bt,null),e(Bt,Wu),e(Bt,wr),e(wr,Fu),e(wr,io),e(io,Hu),e(wr,Yu),e(f,Bu),e(f,Jt),y(Er,Jt,null),e(Jt,Ju),e(Jt,Ar),e(Ar,Ku),e(Ar,po),e(po,Qu),e(Ar,Xu),e(f,Zu),e(f,Kt),y(kr,Kt,null),e(Kt,ef),e(Kt,xr),e(xr,tf),e(xr,ho),e(ho,af),e(xr,rf),e(f,of),e(f,Qt),y(jr,Qt,null),e(Qt,nf),e(Qt,Pr),e(Pr,sf),e(Pr,mo),e(mo,cf),e(Pr,lf),e(f,df),e(f,Xt),y(Dr,Xt,null),e(Xt,pf),e(Xt,Tr),e(Tr,hf),e(Tr,Es),e(Es,mf),e(Tr,uf),e(f,ff),e(f,he),y(zr,he,null),e(he,gf),e(he,Le),e(Le,_f),e(Le,As),e(As,vf),e(Le,$f),e(Le,ks),e(ks,bf),e(Le,yf),e(he,wf),e(he,xs),e(xs,Ef),e(f,Af),e(f,B),y(Or,B,null),e(B,kf),e(B,ee),e(ee,xf),e(ee,js),e(js,jf),e(ee,Pf),e(ee,Ps),e(Ps,Df),e(ee,Tf),e(ee,Ds),e(Ds,zf),e(ee,Of),e(B,If),e(B,Ts),e(Ts,Sf),e(B,Lf),y(Zt,B,null),e(f,Cf),e(f,C),y(Ir,C,null),e(C,Nf),e(C,Ce),e(Ce,qf),e(Ce,zs),e(zs,Uf),e(Ce,Rf),e(Ce,uo),e(uo,Mf),e(Ce,Vf),e(C,Gf),e(C,Os),e(Os,Wf),e(C,Ff),e(C,Is),e(Is,Ss),e(Ss,Hf),e(C,Yf),e(C,U),e(U,Bf),e(U,Ls),e(Ls,Jf),e(U,Kf),e(U,Cs),e(Cs,Qf),e(U,Xf),e(U,Ns),e(Ns,Zf),e(U,eg),e(U,qs),e(qs,tg),e(U,ag),e(U,fo),e(fo,rg),e(U,og),e(C,ng),y(ea,C,null),e(f,sg),e(f,N),y(Sr,N,null),e(N,cg),e(N,Ne),e(Ne,lg),e(Ne,Us),e(Us,ig),e(Ne,dg),e(Ne,go),e(go,pg),e(Ne,hg),e(N,mg),e(N,Rs),e(Rs,ug),e(N,fg),e(N,Ms),e(Ms,Vs),e(Vs,gg),e(N,_g),e(N,I),e(I,vg),e(I,Gs),e(Gs,$g),e(I,bg),e(I,Ws),e(Ws,yg),e(I,wg),e(I,Fs),e(Fs,Eg),e(I,Ag),e(I,Hs),e(Hs,kg),e(I,xg),e(I,Ys),e(Ys,jg),e(I,Pg),e(I,Bs),e(Bs,Dg),e(I,Tg),e(I,_o),e(_o,zg),e(I,Og),e(N,Ig),y(ta,N,null),e(f,Sg),e(f,aa),y(Lr,aa,null),e(aa,Lg),e(aa,Cr),e(Cr,Cg),e(Cr,Js),e(Js,Ng),e(Cr,qg),e(f,Ug),e(f,V),y(Nr,V,null),e(V,Rg),e(V,Ks),e(Ks,Mg),e(V,Vg),e(V,L),e(L,Gg),e(L,Qs),e(Qs,Wg),e(L,Fg),e(L,Xs),e(Xs,Hg),e(L,Yg),e(L,Zs),e(Zs,Bg),e(L,Jg),e(L,ec),e(ec,Kg),e(L,Qg),e(L,tc),e(tc,Xg),e(L,Zg),e(L,ac),e(ac,e_),e(L,t_),e(V,a_),e(V,qr),e(qr,r_),e(qr,rc),e(rc,o_),e(qr,n_),e(V,s_),y(ra,V,null),e(f,c_),e(f,oa),y(Ur,oa,null),e(oa,l_),e(oa,oc),e(oc,i_),e(f,d_),e(f,na),y(Rr,na,null),e(na,p_),e(na,qe),e(qe,h_),e(qe,nc),e(nc,m_),e(qe,u_),e(qe,vo),e(vo,f_),e(qe,g_),e(f,__),e(f,sa),y(Mr,sa,null),e(sa,v_),e(sa,sc),e(sc,$_),gl=!0},p(t,[m]){const Vr={};m&2&&(Vr.$$scope={dirty:m,ctx:t}),We.$set(Vr);const cc={};m&2&&(cc.$$scope={dirty:m,ctx:t}),He.$set(cc);const lc={};m&2&&(lc.$$scope={dirty:m,ctx:t}),At.$set(lc);const ic={};m&2&&(ic.$$scope={dirty:m,ctx:t}),jt.$set(ic);const Gr={};m&2&&(Gr.$$scope={dirty:m,ctx:t}),Pt.$set(Gr);const dc={};m&2&&(dc.$$scope={dirty:m,ctx:t}),Lt.$set(dc);const Wr={};m&2&&(Wr.$$scope={dirty:m,ctx:t}),Ct.$set(Wr);const pc={};m&2&&(pc.$$scope={dirty:m,ctx:t}),Nt.$set(pc);const hc={};m&2&&(hc.$$scope={dirty:m,ctx:t}),qt.$set(hc);const mc={};m&2&&(mc.$$scope={dirty:m,ctx:t}),Rt.$set(mc);const uc={};m&2&&(uc.$$scope={dirty:m,ctx:t}),Yt.$set(uc);const Ue={};m&2&&(Ue.$$scope={dirty:m,ctx:t}),Zt.$set(Ue);const Re={};m&2&&(Re.$$scope={dirty:m,ctx:t}),ea.$set(Re);const fc={};m&2&&(fc.$$scope={dirty:m,ctx:t}),ta.$set(fc);const gc={};m&2&&(gc.$$scope={dirty:m,ctx:t}),ra.$set(gc)},i(t){gl||(w(h.$$.fragment,t),w(ma.$$.fragment,t),w(We.$$.fragment,t),w(He.$$.fragment,t),w(fa.$$.fragment,t),w(ga.$$.fragment,t),w(_a.$$.fragment,t),w(va.$$.fragment,t),w($a.$$.fragment,t),w(ba.$$.fragment,t),w(ya.$$.fragment,t),w(wa.$$.fragment,t),w(Ea.$$.fragment,t),w(Aa.$$.fragment,t),w(ka.$$.fragment,t),w(xa.$$.fragment,t),w(ja.$$.fragment,t),w(Pa.$$.fragment,t),w(Da.$$.fragment,t),w(Ta.$$.fragment,t),w(za.$$.fragment,t),w(Oa.$$.fragment,t),w(Ia.$$.fragment,t),w(Sa.$$.fragment,t),w(La.$$.fragment,t),w(Ca.$$.fragment,t),w(Na.$$.fragment,t),w(At.$$.fragment,t),w(qa.$$.fragment,t),w(Ua.$$.fragment,t),w(Ma.$$.fragment,t),w(Ga.$$.fragment,t),w(jt.$$.fragment,t),w(Fa.$$.fragment,t),w(Pt.$$.fragment,t),w(Ya.$$.fragment,t),w(Ba.$$.fragment,t),w(Ja.$$.fragment,t),w(Qa.$$.fragment,t),w(Za.$$.fragment,t),w(tr.$$.fragment,t),w(ar.$$.fragment,t),w(or.$$.fragment,t),w(Lt.$$.fragment,t),w(Ct.$$.fragment,t),w(Nt.$$.fragment,t),w(sr.$$.fragment,t),w(qt.$$.fragment,t),w(cr.$$.fragment,t),w(lr.$$.fragment,t),w(ir.$$.fragment,t),w(dr.$$.fragment,t),w(Rt.$$.fragment,t),w(mr.$$.fragment,t),w(ur.$$.fragment,t),w(fr.$$.fragment,t),w(gr.$$.fragment,t),w(_r.$$.fragment,t),w(vr.$$.fragment,t),w($r.$$.fragment,t),w(Yt.$$.fragment,t),w(yr.$$.fragment,t),w(Er.$$.fragment,t),w(kr.$$.fragment,t),w(jr.$$.fragment,t),w(Dr.$$.fragment,t),w(zr.$$.fragment,t),w(Or.$$.fragment,t),w(Zt.$$.fragment,t),w(Ir.$$.fragment,t),w(ea.$$.fragment,t),w(Sr.$$.fragment,t),w(ta.$$.fragment,t),w(Lr.$$.fragment,t),w(Nr.$$.fragment,t),w(ra.$$.fragment,t),w(Ur.$$.fragment,t),w(Rr.$$.fragment,t),w(Mr.$$.fragment,t),gl=!0)},o(t){E(h.$$.fragment,t),E(ma.$$.fragment,t),E(We.$$.fragment,t),E(He.$$.fragment,t),E(fa.$$.fragment,t),E(ga.$$.fragment,t),E(_a.$$.fragment,t),E(va.$$.fragment,t),E($a.$$.fragment,t),E(ba.$$.fragment,t),E(ya.$$.fragment,t),E(wa.$$.fragment,t),E(Ea.$$.fragment,t),E(Aa.$$.fragment,t),E(ka.$$.fragment,t),E(xa.$$.fragment,t),E(ja.$$.fragment,t),E(Pa.$$.fragment,t),E(Da.$$.fragment,t),E(Ta.$$.fragment,t),E(za.$$.fragment,t),E(Oa.$$.fragment,t),E(Ia.$$.fragment,t),E(Sa.$$.fragment,t),E(La.$$.fragment,t),E(Ca.$$.fragment,t),E(Na.$$.fragment,t),E(At.$$.fragment,t),E(qa.$$.fragment,t),E(Ua.$$.fragment,t),E(Ma.$$.fragment,t),E(Ga.$$.fragment,t),E(jt.$$.fragment,t),E(Fa.$$.fragment,t),E(Pt.$$.fragment,t),E(Ya.$$.fragment,t),E(Ba.$$.fragment,t),E(Ja.$$.fragment,t),E(Qa.$$.fragment,t),E(Za.$$.fragment,t),E(tr.$$.fragment,t),E(ar.$$.fragment,t),E(or.$$.fragment,t),E(Lt.$$.fragment,t),E(Ct.$$.fragment,t),E(Nt.$$.fragment,t),E(sr.$$.fragment,t),E(qt.$$.fragment,t),E(cr.$$.fragment,t),E(lr.$$.fragment,t),E(ir.$$.fragment,t),E(dr.$$.fragment,t),E(Rt.$$.fragment,t),E(mr.$$.fragment,t),E(ur.$$.fragment,t),E(fr.$$.fragment,t),E(gr.$$.fragment,t),E(_r.$$.fragment,t),E(vr.$$.fragment,t),E($r.$$.fragment,t),E(Yt.$$.fragment,t),E(yr.$$.fragment,t),E(Er.$$.fragment,t),E(kr.$$.fragment,t),E(jr.$$.fragment,t),E(Dr.$$.fragment,t),E(zr.$$.fragment,t),E(Or.$$.fragment,t),E(Zt.$$.fragment,t),E(Ir.$$.fragment,t),E(ea.$$.fragment,t),E(Sr.$$.fragment,t),E(ta.$$.fragment,t),E(Lr.$$.fragment,t),E(Nr.$$.fragment,t),E(ra.$$.fragment,t),E(Ur.$$.fragment,t),E(Rr.$$.fragment,t),E(Mr.$$.fragment,t),gl=!1},d(t){a(d),t&&a(x),t&&a(u),A(h),t&&a(Ve),t&&a(H),t&&a(ha),t&&a(ve),A(ma),t&&a(zc),t&&a(Yr),t&&a(Oc),t&&a(te),t&&a(Ic),A(We,t),t&&a(Sc),t&&a(be),t&&a(Lc),A(He,t),t&&a(Cc),t&&a(Ye),t&&a(Nc),t&&a(ye),A(fa),t&&a(qc),t&&a(we),A(ga),t&&a(Uc),t&&a(Ee),t&&a(Rc),A(_a,t),t&&a(Mc),t&&a(Ae),A(va),t&&a(Vc),t&&a(ke),A($a),t&&a(Gc),t&&a(Xe),t&&a(Wc),A(ba,t),t&&a(Fc),t&&a(Ze),t&&a(Hc),A(ya,t),t&&a(Yc),t&&a(xe),A(wa),t&&a(Bc),t&&a(tt),t&&a(Jc),A(Ea,t),t&&a(Kc),t&&a(at),t&&a(Qc),A(Aa,t),t&&a(Xc),t&&a(je),A(ka),t&&a(Zc),t&&a(to),t&&a(el),A(xa,t),t&&a(tl),A(ja,t),t&&a(al),t&&a(Pe),A(Pa),t&&a(rl),t&&a(nt),t&&a(ol),t&&a(De),A(Da),t&&a(nl),t&&a(ct),t&&a(sl),A(Ta,t),t&&a(cl),t&&a(ae),t&&a(ll),A(za,t),t&&a(il),t&&a(Te),A(Oa),t&&a(dl),t&&a(W),t&&a(pl),t&&a(ze),A(Ia),t&&a(hl),t&&a(ht),t&&a(ml),A(Sa,t),t&&a(ul),t&&a(Oe),A(La),t&&a(fl),t&&a(f),A(Ca),A(Na),A(At),A(qa),A(Ua),A(Ma),A(Ga),A(jt),A(Fa),A(Pt),A(Ya),A(Ba),A(Ja),A(Qa),A(Za),A(tr),A(ar),A(or),A(Lt),A(Ct),A(Nt),A(sr),A(qt),A(cr),A(lr),A(ir),A(dr),A(Rt),A(mr),A(ur),A(fr),A(gr),A(_r),A(vr),A($r),A(Yt),A(yr),A(Er),A(kr),A(jr),A(Dr),A(zr),A(Or),A(Zt),A(Ir),A(ea),A(Sr),A(ta),A(Lr),A(Nr),A(ra),A(Ur),A(Rr),A(Mr)}}}const Vb={local:"accelerator",sections:[{local:"quick-adaptation-of-your-code",title:"Quick adaptation of your code"},{local:"advanced-recommendations",sections:[{local:"printing",title:"Printing"},{local:"executing-processes",sections:[{local:"once-on-a-single-server",title:"Once on a single server"},{local:"only-ever-once-across-all-servers",title:"Only ever once across all servers"},{local:"on-specific-processes",title:"On specific processes"}],title:"Executing processes"},{local:"synchronicity-control",title:"Synchronicity control"},{local:"saving-and-loading",title:"Saving and loading"},{local:"operations",title:"Operations"},{local:"gradient-accumulation",title:"Gradient Accumulation"}],title:"Advanced recommendations"},{local:"accelerate.Accelerator",title:"Overall API documentation:"}],title:"Accelerator"};function Gb(D){return kb(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Kb extends yb{constructor(d){super();wb(this,d,Gb,Mb,Eb,{})}}export{Kb as default,Vb as metadata};
